# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields

MEIO_PAGAMENTO = [
    ('01', 'Dinheiro'),
    ('02', 'Cheque'),
    ('03', 'Cartao de credito'),
    ('04', 'Cartao de debito'),
    ('05', 'Credito loja'),
    ('10', 'Vale alimentacao'),
    ('11', 'Vale refeicao'),
    ('12', 'Vale presente'),
    ('13', 'Vale combustivel'),
    ('14', 'Duplicata mercantil'),
    ('15', 'Boleto bancario'),
    ('16', 'Deposito bancario'),
    ('17', 'Pagamento instantaneo (PIX)'),
    ('18', 'Transferencia bancaria, Carteira digital'),
    ('19', 'Programa de fidelidade, Cashback, Credito virtual'),
    ('90', 'Sem pagamento'),
    ('99', 'Outros')
]

class adm_forma_pgto(osv.Model):
    """
    Tabela de tipos de moedas usado nas transacoes financeiras.
    """
    _name = 'adm.forma.pgto'  # admfpg
    _columns = {
        'name': fields.char('Descricao', size=30, required=True), # Descricao do tipo de moeda
        'bloqueio': fields.boolean('Bloqueio'), # True=Bloqueio, nao pode ser excluido. \nFalse=Nao bloqueia, pode ser excluido
        'sigla': fields.char('Sigla', size=3, select=True), # Sigla para identificacao do tipo de moeda
        'active': fields.boolean('Ativo'),
        'condicao_forma_ids': fields.one2many('adm.condicao.forma', 'forma_pagamento_id',
                                              "Condicoes/Formas de Pagamento"),
        'admfpg_cartao_pessoa_id': fields.many2one("adm.pessoa", 'Operadora de Cartao', select=True,
                                                   domain=[('admpes_jur_tipo_empresa', '=', 'A')]),
        'admfpg_tipo': fields.selection(MEIO_PAGAMENTO, 'Forma de pagamento'),
    }

    _defaults = {
        'bloqueio': lambda *a: False,
        'active': lambda *a: True,
    }
