# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class adm_impressora(osv.Model):
    """
    Tabela de impressoras
    """

    #prefixo = admimp_

    PRINTER_CHOICES = [('', '')]
    TIPOS = [('1', 'PDF'),
             ('2', 'Matricial'),
             ('3', 'Termica')]
    _name = 'adm.impressora'
    _columns = {
        'company_id': fields.many2one('res.company', 'Empresa', required=True),
        'admimp_cups': fields.char(string='Nome no Cups', size=100, required=True),
        'admimp_obs': fields.char(string='Observacao', size=100,),
        'admimp_tipo': fields.selection(TIPOS, 'Tipo de impressao', size=2, required=True),
        'admimp_user_id': fields.many2one('res.users', 'Usuario',
                                          help="Selecionando um usuario, somente"
                                               " ele podera imprmir nessa impressora!"),
        'admimp_modelo_id': fields.many2one('adm.impressora.modelo', 'Modelo'),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'adm.impressora', context=c),
    }
