#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class wizard_listagem_impressoras(osv.TransientModel):
    """
    Este wizard exibe todas as impressoras cadastras.
    Pode ser utilizado em qualquer lugar.
    Para utiliza-lo, e necessario passar a chave 'insert_printer_on_field' no contexto,
    informando em qual campo a impressora escolhida na tela será gravado.
    """

    PRINTER_CHOICES = [('', '')]
    _name = 'wizard.listagem.impressora'
    _rec_name = 'wlist_printer'
    _columns = {
        'wlist_printer': fields.selection(PRINTER_CHOICES, string='Impressoras', required=True)
    }

    def get_printer_label(self, choice):
        label = dict(self.PRINTER_CHOICES).get(choice) or ''
        if ' -> ' in label:
            label = label.split(' -> ')[-1]

        return label

    def button_list_printer(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]

        active_model = context.get('active_model')
        active_id = context.get('active_id')
        field_to_insert = context.get('insert_printer_on_field')

        if active_model and active_id and field_to_insert:
            listagem_impressora_dados = self.read(cr, uid, ids, ['wlist_printer'], context=context)
            for i in listagem_impressora_dados:
                impressoa = i.get('wlist_printer')
                impressoa_nome = self.get_printer_label(impressoa)
                self.pool.get(active_model).write(cr, uid, [active_id], {field_to_insert: impressoa_nome}, context=context)
        return True

    def fields_view_get(self, cr, user, view_id=None, view_type=False, context=None, toolbar=False,
                        submenu=False):
        context = context and context.copy() or {}
        res = super(wizard_listagem_impressoras, self).fields_view_get(
            cr, user, view_id=view_id, view_type=view_type, context=context, toolbar=toolbar,
            submenu=submenu)
        # -------------- Pega as impressoras que estao ligadas na rede-----------------------------
        obj_impressora = self.pool.get('adm.impressora')
        args = [('admimp_user_id', 'in', [user, False, None])]
        impressora_ids = obj_impressora.search(cr, user, args)
        printers = {}
        if not impressora_ids:
            printers = {'Sem impressoras cadastradas no ADM': ''}
        else:
            for i in obj_impressora.name_get(cr, user, impressora_ids):
                printers[i[1]] = i[0]

        printer_names = printers.keys()
        # SE O INDICE COMECA COM ZERO, NAO ACEITA SER SELECIONADO.
        printer_len = map(str, range(1, printer_names.__len__() + 1))
        self.PRINTER_CHOICES = zip(printer_len, printer_names)
        self._columns['wlist_printer'].selection = self.PRINTER_CHOICES
        res['fields']['wlist_printer']['selection'] = self.PRINTER_CHOICES
        return res
