# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_parametro(osv.Model):
    """
    Heranca da classe ´estoque_parametro´.
    """

    _inherit = "estoque.parametro"
    _columns = {
        'estpar_impressora_termica': fields.char('Impressora termica', size=64),
        'estpar_impressora_termica_servidor': fields.char('Servidor', size=64,
                                                          help='Informe o servidor de impressao e a porta, caso na esteja configurado no servidor SigERP. Ex:192.168.1.1:631'),
        'estpar_modelo_etiquetas_ids': fields.one2many('automacao.modelo.etiqueta',
                                                       'autmet_estoque_parametro_id'),
        'estpar_qtd_digitos': fields.integer('QTD Digitos etiqueta de balanca'),
        'estpar_desconto_a_vista': fields.float('Desconto a vista', digits=(3, 2),
                                                help="Percentual de desconto para vendas a vista, "
                                                     "apenas para etiqueta de gondola, nao altera o "
                                                     "preco do produto no sistema!"), # Preco
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
