# -*- encoding: utf-8 -*-
# ##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class banfin_bolpag_notificacoes(osv.Model):

    _inherit = 'banfin.bolpag.notificacoes'

    def banfin_not_bp_btn_processar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = self.banfin_not_bp_processar_notificacoes(cr, uid, ids, context=context)
        if not res.get('status'):
            raise osv.except_osv(_('Atencao'), res.get('mensagem'))
        return res

    def banfin_not_bp_processar_notificacoes(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        _msg = []
        for bolPagcNotificacoesBrw in self.browse(cr, uid, ids, context=context):
            _titulo_id = int(bolPagcNotificacoesBrw.banfin_not_bp_seu_numero.split('-')[0])
            financeiroTituloBrw = self.pool.get('financeiro.titulo').browse(cr, uid, _titulo_id, context=context)
            if not financeiroTituloBrw:
                _msg.append(_('Nao encontrei tilulo para o ID "%s"\n') % _titulo_id)
                continue
            if bolPagcNotificacoesBrw.banfin_not_bp_situacao in ('A_RECEBER', "CANCELADO", "EXPIRADO"):
                vals = {
                    'state': 'E',
                    'banfin_not_bp_mensagem_erro': '',
                }
                self.write(cr, uid, bolPagcNotificacoesBrw.id, vals, context=context)
                continue
            if bolPagcNotificacoesBrw.banfin_not_bp_situacao in ('MARCADO_RECEBIDO', "RECEBIDO"):
                if financeiroTituloBrw.state == 'B':  # Titulo já esta baixado
                    vals = {
                        'state': 'E',
                        'banfin_not_bp_mensagem_erro': '',
                    }
                    self.write(cr, uid, bolPagcNotificacoesBrw.id, vals, context=context)
                    continue
                if financeiroTituloBrw.state != 'A':  # Titulo não pode ser baixado
                    vals = {
                        'state': 'X',
                        'banfin_not_bp_mensagem_erro': 'Titulo nao pode ser baixado!',
                    }
                    self.write(cr, uid, bolPagcNotificacoesBrw.id, vals, context=context)
                    continue
                if not bolPagcNotificacoesBrw.banfin_not_bp_conta_id:
                    _msg.append(_('Nao encontrei conta da tesouraria para o ID "%s"') % _titulo_id)
                    continue
                _juros = _descontos = _multa = 0
                if bolPagcNotificacoesBrw.banfin_not_bp_valor < financeiroTituloBrw.vr_original:
                    _descontos = financeiroTituloBrw.vr_original - bolPagcNotificacoesBrw.banfin_not_bp_valor
                elif bolPagcNotificacoesBrw.banfin_not_bp_valor > financeiroTituloBrw.vr_original:
                    _juros = bolPagcNotificacoesBrw.banfin_not_bp_valor - financeiroTituloBrw.vr_original
                _titulos = [
                    {
                        'titulo_id': financeiroTituloBrw.id,
                        'valor_pago': bolPagcNotificacoesBrw.banfin_not_bp_valor,
                        'saldo_baixado': financeiroTituloBrw.vr_original,
                        'valor_multa': 0,
                        'valor_juros': _juros,
                        'valor_desconto': _descontos,
                        'tipo_titulo': financeiroTituloBrw.tipo_titulo,
                        'pessoa_id': financeiroTituloBrw.pessoa_id.id
                    }
                ]
                forma_pagamento_id = self.pool.get('adm.forma.pgto').search(cr, uid, [('name', 'ilike', 'dinheiro')],
                                                               context=context)[0]

                self.pool.get('financeiro').financ_baixar_titulo(
                    cr, uid,
                    futl_bxti_titulos=_titulos,
                    futl_bxti_data_pagamento=bolPagcNotificacoesBrw.banfin_not_bp_data_movimento[:10],
                    ftul_bxti_forma_pgto_id=forma_pagamento_id,
                    futl_bxti_tesouraria_conta_id=bolPagcNotificacoesBrw.banfin_not_bp_conta_id.id,
                    futl_bxti_pessoa_id=financeiroTituloBrw.pessoa_id.id,
                    context=context)
                vals = {
                    'state': 'E',
                    'banfin_not_bp_mensagem_erro': '',
                }
                self.write(cr, uid, bolPagcNotificacoesBrw.id, vals, context=context)
                continue
        if not _msg:
            return {'status': True, 'mensagem': ''}
        return {'status': False, 'mensagem': '\n'.join(_msg)}

