# -*- encoding: utf-8 -*-
# ##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class banfin_bolpg_notificacoes(osv.Model):

    _name = 'banfin.bolpag.notificacoes'
    """
        Classe de notificacoes de boletos a pagar, recebidas dos bancos
        prefixo: banfin_not_bp_
    """
    _rec_name = 'banfin_not_bp_cod_transacao'
    _columns = {
        'id': fields.integer('Id', readonly=True),
        'company_id': fields.many2one("res.company", 'Empresa', select=True, ondelete='cascade'),
        'create_date': fields.datetime('Data', readonly=True),
        'create_uid': fields.many2one('res.users', 'Usuario', ondelete='cascade', select=True, readonly=True),
        'banfin_not_bp_conta_id': fields.many2one('financeiro.tesouraria.contas', 'Conta tesouraria', select=True, ondelete='cascade'),
        'banfin_not_bp_cod_interno_bc': fields.char('Codigo interno', size=20),
        'banfin_not_bp_linha_digitavel': fields.char('Codigo barras', size=48),
        'banfin_not_bp_cod_transacao': fields.char('Codigo transacao', size=36, select=True),
        'banfin_not_bp_data_movimento': fields.datetime('Data/Hora agendamento'),
        'banfin_not_bp_data_solicitacao': fields.datetime('Data/Hora Solicitacao'),
        'banfin_not_bp_situacao': fields.char('Situacao', size=20),# "REALIZADO" "AGENDADO" "CANCELADO" "ERRO"
        'banfin_not_bp_valor': fields.float('Valor', digits=(10, 2)),
        'banfin_not_bp_recebedor_cnpj' : fields.char('Recebedor Cnpj', size=14),
        'banfin_not_bp_recebedor_nome' : fields.char('Recebedor Nome', size=40),
        'state': fields.selection([('R', 'Recebido'), ('E', 'Executado'), ('X', 'Erro')], 'Estado', size=1),
        'banfin_not_bp_mensagem_erro': fields.text('Mensagem'),
    }
    _defaults = {
        'state': 'R',
    }
    _order = 'id desc'
