# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
from SigUtils.crypto import decrypt
import base64
import requests
import json

pkey_sig = """-----BEGIN RSA PRIVATE KEY-----
MIICXQIBAAKBgQDNlPEHacb00nIQ7rrZ3U4kL9QAU+vvXbLLHGR45+7zYb2cBE2s
qmnUpSgf2Jp2HL0Dz/paqxpB4pOxU6kEcDs1QOlTjt5rTsKKiw6Of7g1MsrIEQCz
tF+u8xXyl93JB0M2QBQ4PGVQQsHxyd+jdWHCOj/YpJCA/8rJUbhiVoRaQwIDAQAB
AoGBAMnIdUO3eUb4AGnKSLBq3bX7E/U2ag/KQiHGPn/F9u4Ac6FdP/hIVBQZ/2Yy
rnlb/9JsIuk3pFAi2qBk4zKuDg2V57DY+h31SLVjENZHD3M0MGonFzu1uay+s/m0
X0mMbueNXuWAAYkoAPL/wEjP/ciJkqfCUiOJADcf7PJhXfhxAkEA9F1mdw+z+GPu
tHabZ2WJJSb7JnZtAskG/spFye6UUUw53tC7mLZ7Ye3dESa3l9jtRfC4CSKbNJhX
9JyTkzcabQJBANdezxdVg4gbBbdBm6cf59aT7Y1KIrqkDtQpENBJVMXJUIa2CTEc
QvGE3UwOA37zLRFtkSZk0w1590wC7NkwWW8CQBmr+kjF0I1myjwRPdBF/Xt2tenb
hSZGwkJgM6a8Nr63uFitKxgnC51FJPVZUO5V7s9rM5paFV4YJx1ema5cmp0CQQCo
gwgqS8CEqBAK2Qy+8RnnLQt7t3wA6QipPBBpyFbKAsA9BwWeJWzDqJ+2OGjH1eF3
d3FQxybTrpCuKsPDFC+FAkALWOoMA+liEcsz/n7BardljL0BRDuqMaS2iuQ/RTAH
34xfgVdzAN8XNLA+FOAWMxyDxP1vfoa6SwUsTZsdebGa
-----END RSA PRIVATE KEY-----"""


class coletor_dispositivo(osv.Model):
    _inherit = 'coletor.dispositivo'

    def coldis_cadastrar_dispositivo(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        nro_serie = vals.get('serial')
        modelo = vals.get('model')
        marca = vals.get('brand')
        cnpj = vals.get('cnpj')
        args = [('coldis_nro_serie', '=', nro_serie),
                ('coldis_modelo', '=', modelo),
                ('coldis_marca', '=', marca),
                ('coldis_cnpj', '=', cnpj)]
        dispositivo_ids = self.search(cr, uid, args, context=context)
        if not dispositivo_ids:
            vals_disp = {'coldis_nro_serie': nro_serie,
                         'coldis_modelo': modelo,
                         'coldis_marca': marca,
                         'coldis_cnpj': cnpj}
            dispositivo_ids = [self.create(cr, uid, vals_disp, context=context)]

        return dispositivo_ids

    def coldis_check_licenca(self, cr, uid, vals, dispositivo_ids, context=None):
        context = context and context.copy() or {}
        # verifica a licenca do ERP primeiro
        try:
            self.pool.get('valida.pendencias').valpen_verificar_licenca_ativa(cr, uid, context)
        except Exception as e:
            return False, str(e)

        nro_serie = vals.get('serial')
        modelo = vals.get('model')
        marca = vals.get('brand')
        licenca = self.read(cr, uid, dispositivo_ids[0], ['coldis_licenca'],
                            context=context).get('coldis_licenca')
        if not licenca:
            res, msg = self.coldis_gerar_licenca(cr, uid, dispositivo_ids, context)
            if not res:
                return res, msg

            licenca = self.read(cr, uid, dispositivo_ids[0], ['coldis_licenca'],
                                context=context).get('coldis_licenca')
        try:
            licenca = decrypt(licenca, pkey_sig).split('#|#')
        except:
            return False, _('Erro ao descriptografar licenca')

        if len(licenca) != 3 or modelo != licenca[0] or marca != licenca[1] or \
                nro_serie != licenca[2]:
            return False, _('Licenca invalida para este dispositivo!')

        return True, _('Licenca verificada!')

    def coldis_gerar_licenca(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_config_parameter = self.pool.get('ir.config_parameter')
        campos = ['coldis_marca', 'coldis_modelo', 'coldis_nro_serie', 'coldis_cnpj']
        dados_dispositivo = self.read(cr, uid, ids[0], campos, context=context)
        servidor = obj_config_parameter.get_sig_server(cr, uid, context=context).split(',')
        try:
            host = servidor[0]
            db = servidor[1]
            porta = servidor[2]
            user = servidor[3]
            senha = servidor[4]
            res = requests.post('https://%s/contrecf/get_mobile_licenca' % host,
                                auth=(user, senha),
                                data={'db': db,
                                      'pwd': senha,
                                      'user': user,
                                      'url': host,
                                      'port': porta,
                                      'marca': dados_dispositivo.pop('coldis_marca'),
                                      'modelo': dados_dispositivo.pop('coldis_modelo'),
                                      'nro_serie': dados_dispositivo.pop('coldis_nro_serie'),
                                      'cnpj': dados_dispositivo.pop('coldis_cnpj'),
                                      },
                                timeout=10000)
            res = json.loads(res.content)
            if res.get('codigo') != '00':
                return False, res.get('mensagem')

        except Exception as e:
            return False, _('Erro comunicando com servidor da SIG!:\n%s') % e

        res = res.get('retorno')[0]
        if not res[0]:
            return False, res[1]

        licenca = base64.decodestring(res[1])
        vals = {'coldis_licenca': licenca}
        self.write(cr, uid, ids, vals, context=context)
        return True, _('Licenca gerada!')

    def coldis_button_gerar_licenca(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res, msg = self.coldis_gerar_licenca(cr, uid, ids, context)
        if not res:
            raise osv.except_osv(_('Atencao!'), msg)

        return res

    def coldis_busca_produto_balanca(self, cr, uid, cb, context=None):
        context = context and context.copy() or {}
        retorno = {'erro': '', 'ret': {}}
        res = self.pool.get('estoquepedidos.pedido.capa').pedcap_busca_produto_balanca(cr, uid, cb, context)
        if isinstance(res, dict):
            retorno['erro'] = res.get('warning').get('message')
            return retorno

        vr_unitario = str(res[1])
        vr_unitario = vr_unitario.replace('.', ',')
        if vr_unitario[len(vr_unitario) - 2:len(vr_unitario) - 1] == ',':
            vr_unitario += '0'

        vr_total = str(res[2])
        vr_total = vr_total.replace('.', ',')
        if vr_total[len(vr_total) - 2:len(vr_total) - 1] == ',':
            vr_total += '0'

        retorno['ret'] = {'qtd': res[0],
                          'vr_unitario': vr_unitario,
                          'vr_total': vr_total,
                          'cb_id': res[3].id}
        return retorno
