# -*- coding: utf-8 -*-
#
# OBS: para funcionar eh preciso que tenha a pasta 'static' dentro do modulo

import openerp.addons.web.http as http
import json
from ..valida.controller import Config, MySock as Ms
from logging import getLogger
_logger = getLogger("ContrEcf")

SEM_ERRO = '00'
ERRO_NA_LICENCA = '10'
ERRO_INTERNO = '99'


class MySock(Ms):
    def execute(self, model, function, *args):
        return self.sock.execute(self.db, self.uid, self.pwd, model, function, *args)


class sc_contrecf(http.Controller):
    _cp_path = '/contrecf'

    @http.httprequest
    def teste(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        ip = req.httprequest.environ.get('REMOTE_ADDR')
        print(ip)
        return 'Resposta Teste: ' + ip

    @http.httprequest
    def get_mobile_licenca(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        try:
            sock = MySock(req.params)
            vals = {'marca': req.params.get('marca'),
                    'modelo': req.params.get('modelo'),
                    'nro_serie': req.params.get('nro_serie'),
                    'cnpj': req.params.get('cnpj')}
            res = sock.execute('contrecf.mobile', 'get_mobile_licenca', vals, {})
            if not res or not res[0]:
                return json.dumps({'retorno': [],
                                   'codigo': ERRO_NA_LICENCA,
                                   'mensagem': res and res[1] or 'Erro ao gerar a licenca no serividor '
                                                                 'SIG'})

            return json.dumps({'retorno': [res],
                               'codigo': SEM_ERRO,
                               'mensagem': 'ok'})
        except Exception as e:
            return json.dumps({'codigo': ERRO_INTERNO,
                               'mensagem': 'Erro: %s' % e,
                               'retorno': []})
