# -*- encoding: utf-8 -*-
##############################################################################
#
# OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from datetime import datetime, timedelta

from openerp.osv import osv

READ_LOAD = '_classic_write'


# noinspection PyUnresolvedReferences,PyUnresolvedReferences
class crm_br_utils(osv.Model):

    _name = "crm_br.utils"

    def crmutl_get_dados_painel(self, cr, uid, dados, context=None):
        context = context and context.copy() or {}
        obj_section = self.pool.get('crm_br.case.section')
        obj_criticidade = self.pool.get('crm_br.case.criticidade')
        section_id = obj_section.search(cr, uid, [('code', '=', 'nivel2')])[0]
        args = [('state', '=', 'open'),
                ('section_id', '=', section_id)]
        obj_case = self.pool.get('crm_br.case')
        obj_log = self.pool.get('crm_br.case.log')
        case_ids = obj_case.search(cr, uid, args, context=context)
        if not case_ids:
            return {}

        res = {}
        campos = ['user_id', 'crmcas_criticidade', 'date', 'log_ids']
        dados_case = obj_case.read(cr, uid, case_ids, campos, context)
        log_ids = []
        for i in dados_case:
            log_ids.extend(i.get('log_ids'))

        dict_log = {}
        for i in obj_log.read(cr, uid, log_ids, ['crmcal_tempo_atend', 'crmcal_date', 'name']):
            dict_log[i.get('id')] = i

        criticidade_ids = obj_criticidade.search(cr, uid, [])
        dict_criticidade = {}
        for i in obj_criticidade.read(cr, uid, criticidade_ids, []):
            dict_criticidade.update({i.get('crmcri_criticidade'): i.get('crmcri_tempo_limite')})

        usurio_ids = []
        for case in dados_case:
            case.get('date')
            user_id = case.get('user_id')[0]
            usurio_ids.append(user_id)
            soma_tempo = 0
            hora_aberta = False
            for i in case.get('log_ids'):
                log = dict_log.get(i)
                soma_tempo += log.get('crmcal_tempo_atend')
                if log.get('name') == 'Aberto' and (not hora_aberta or
                                                  (str(hora_aberta) < log.get('crmcal_date'))):
                    hora_aberta = datetime.strptime(log.get('crmcal_date'), '%Y-%m-%d %H:%M:%S')

            criticidade = {'B': 'Baixa', 'A': 'Alta', 'M': 'Média'}
            dif = datetime.now() - hora_aberta
            soma_tempo += dif.days * 24 + (float(dif.seconds) / 3600)
            tempo_limit = dict_criticidade.get(case.get('crmcas_criticidade') or 'B')
            tempo_atend = str(timedelta(hours=soma_tempo)).split('.')[0]
            restricao = 0
            if soma_tempo > tempo_limit:
                restricao = 1

            vals = {'nome': ' '.join(case.get('user_id')[1].split(' ')[:2]),
                    'aberto_id': str(case.get('id')),
                    'data': str(case.get('date')),
                    'tempo_aberto': tempo_atend,
                    'criticidade': criticidade.get(case.get('crmcas_criticidade') or 'B'),
                    'restricao': restricao}
            res[case.get('user_id')[1]] = vals

        args = [('state', 'in', ['pending', 'parado', 'draft']),
                ('user_id', 'in', usurio_ids),
                ('section_id', '=', section_id)]
        case_ids = obj_case.search(cr, uid, args, order='id', context=context)
        for case in obj_case.read(cr, uid, case_ids, ['id', 'user_id'], context):
            if not res[case.get('user_id')[1]].get('atividades'):
                res[case.get('user_id')[1]]['atividades'] = [str(case.get('id'))]
            else:
                res[case.get('user_id')[1]]['atividades'].append(str(case.get('id')))
        for i in res:
            if res[i].get('atividades'):
                res[i]['atividades'].sort()

        return res