# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2010 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
from ...kit.model.funcoes import get_preco_total_venda_itens_kit
from ...financeiro.model.funcoes import fincli_get_bloqueio

from SigUtils.formatastring import unicode_to_ascii
from re import sub as re_sub
import re
import itertools as it
from decimal import Decimal
from datetime import datetime
import traceback

f_txt = lambda txt, tam: unicode_to_ascii(txt).ljust(tam)[:tam]


READ_LOAD = '_classic_write'

TWOPLACES = Decimal(10) ** -2


class ecf_utils(osv.Model):
    _name = 'ecf.utils'

    def ecfuti_get_funcao(self, cr, uid, model, function, *args):
        # Funcao ultilizada pelo controller para acessar as funcoes do ERP via XMLRPC
        try:
            _args = ','.join(map(lambda x: '%r' % x, args))
            return eval("self.pool.get('{model}').{function}(cr, uid, {args})".format(
                model=model,
                function=function,
                args=_args))
        except Exception as e:
            txt = ''
            if e.__class__ in (osv.orm.except_orm, osv.except_osv) and len(e.args) > 1:
                txt = e.args[0].encode('utf-8') + ' ' + e.args[1].encode('utf-8')
            else:
                try:
                    txt = e.message or e.value
                except:
                    txt = str(e)

            txt += traceback.format_exc()
            txt = self.pool.get('adm.utils').admutl_remover_acentuacao(cr, uid, txt)
            raise Exception('9999', txt)

    def ecfuti_get_kit(self, cr, uid, company_id, context=None):
        context = context and context.copy() or {}
        res = False, []
        ep_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid,
                                                                       'estoque.produto', context=context,
                                                                       user_company_id=company_id)
        obj_estoque_produto = self.pool.get('estoque.produto')
        # ler kits
        produtos_ids = obj_estoque_produto.search(cr, uid, [('company_id', '=', ep_company_id),
                                                            ('kit_de_produtos', '=', True),
                                                            ('tipo_kit', '=', 'I')],
                                                  context=context)
        if not produtos_ids:
            return res

        msg_kit = []
        msg_kit_item_erro = []
        vals_kit = []
        for produto_id in produtos_ids:
            vals = {}
            sql_kitpro = """
                SELECT kp.id,
                       kp.kitpro_quantidade         AS kitpro_quantidade,   
                       kp.kitpro_preco_venda        AS kitpro_preco_venda,
                       kp.kitpro_item_produto_id,
                       kp.kitpro_grade_id,
                       kp.kitpro_produto_embalagem_id,
                       acb.codigo_barra             AS acb_codigo_barra_kit,
                       -- Busca apenas 1 codigo de barras para grades com mais de 1 cb
                       (SELECT acb2.codigo_barra 
                        FROM automacao_codigo_barra AS acb2
                        WHERE acb2.grade_id = kp.kitpro_grade_id
                          AND acb2.produto_embalagem_id = kp.kitpro_produto_embalagem_id
                          AND acb2.active = True
                        LIMIT 1)                    AS acb_codigo_barra_item_kit,
                       ep.name                      AS estpro_name,
                       ep.codigo                    AS estpro_codigo,
                       ep2.codigo                   AS estpro_codigo_item
                FROM   kit_produto                AS kp
                INNER JOIN estoque_produto        AS ep  ON ep.id = kp.kitpro_produto_id
                INNER JOIN estoque_produto        AS ep2 ON ep2.id = kp.kitpro_item_produto_id
                INNER JOIN automacao_codigo_barra AS acb ON acb.produto_id = kp.kitpro_produto_id
                WHERE  kp.kitpro_produto_id = {produto_id}""".format(produto_id=produto_id)
            cr.execute(sql_kitpro)
            kitpro = cr.dictfetchall()
            if kitpro and isinstance(kitpro, list):
                for kit_cb in list(set(map(lambda x: x.get('acb_codigo_barra_kit'), kitpro))):
                    kit_pro_aux = filter(lambda x: x.get('acb_codigo_barra_kit') == kit_cb, kitpro)
                    kit_ids = []
                    pular_kit = False
                    for i in kit_pro_aux:
                        kit_ids.append(i.get('id'))
                        if not i.get('kitpro_preco_venda'):
                            pular_kit = True
                            break

                    if pular_kit:
                        continue

                    try:
                        preco_total_kit_itens = get_preco_total_venda_itens_kit(self, cr, uid, kit_ids,
                                                                                context=context)
                    except Exception as e:
                        msg_kit.append(str(e))
                        continue

                    for kit in kit_pro_aux:
                        supkit_loja = ep_company_id
                        supkit_codigo_barra_kit = kit.get('acb_codigo_barra_kit')
                        supkit_codigo_barra_item = kit.get('acb_codigo_barra_item_kit')
                        if not supkit_codigo_barra_item:
                            txt_erro = '%s-%s -->ITEM: %s' % (kit.get('estpro_codigo'),
                                                              kit.get('estpro_name'),
                                                              kit.get('estpro_codigo_item'))
                            if txt_erro not in msg_kit_item_erro:
                                msg_kit_item_erro.append(txt_erro)

                            continue

                        supkit_quantidade = kit.get('kitpro_quantidade')
                        supkit_preco_venda = preco_total_kit_itens.get(kit.get('id'))
                        # deve buscar o codigo do kit e do item no supervisor
                        vals.update({'cb_kit': supkit_codigo_barra_kit,
                                     'cb_item': supkit_codigo_barra_item,
                                     'supkit_loja': supkit_loja,
                                     'supkit_codigo_barra_kit': supkit_codigo_barra_kit,
                                     'supkit_codigo_barra_item': supkit_codigo_barra_item,
                                     'supkit_quantidade': supkit_quantidade,
                                     'supkit_preco_venda': supkit_preco_venda})
            if vals:
                vals_kit.append(vals)

        if not vals_kit:
            msg_kit = [_('\nNenhum Kit importado ou Existem Itens em Kits que nao '
                         'foram importados. Realize a importacao de itens e '
                         'tent novamente.'), '\n', '\n'.join(msg_kit), '\n', ''.ljust(120, '-'), '\n']
        if msg_kit_item_erro:
            msg_kit = [_('\nErro no cadastro de kit, recadastre o(s) kit(s):'),
                       '\n'.join(msg_kit_item_erro)] + msg_kit
            if vals_kit:
                msg_kit += ''.ljust(120, '-'), '\n'

        return msg_kit, vals_kit

    def ecfuti_get_vendedores(self, cr):
        sql = """
            SELECT vendedor.id,
                   pessoa.nome
            FROM   vendas_vendedor vendedor
                   inner join adm_pessoa pessoa
                           ON pessoa.id = vendedor.pessoa_id
            GROUP  BY vendedor.id,
                      pessoa.nome  """
        cr.execute(sql)
        dados_vendedores = cr.dictfetchall()
        if dados_vendedores:
            msg = _('\n%s Vendedores Importados.' % len(dados_vendedores)) + '\n' + ''.ljust(120, '-') + '\n'
        else:
            msg = _('\nNenhum vendedor Importado.') + '\n' + ''.ljust(120, '-') + '\n'

        return msg, dados_vendedores

    def get_dados_cliente_postgres(self, cr, cliente_ids):
        res = list()
        if not cliente_ids:
            return res
        if len(cliente_ids) == 1:
            cliente_ids = str(tuple(cliente_ids)).replace(',', '')
        else:
            cliente_ids = str(tuple(cliente_ids))

        sql = """
            SELECT ap.id               AS pessoa_id,
                   ap.cpf_cnpj,
                   ap.nome,
                   ap.codigo           AS codigo_interno,
                   ap.admpes_jur_ie,
                   ap.pessoa_tipo,
                   ap.email,
                   ap.endereco,
                   Min(ape.numero)     AS numero,
                   ap.bairro,
                   ap.cidade,
                   ap.codigo_ibge,
                   ap.uf,
                   ap.cep,
                   fc.id               AS cliente_id,
                   fc.limite_credito,
                   fc.fincli_rota,
                   Min(apt.numero)     AS telefone,
                   Sum(ft.saldo)       AS total_em_aberto,
                   fc.active
            FROM   adm_pessoa             AS ap
            INNER JOIN financeiro_cliente AS fc  ON fc.pessoa_id = ap.id
            LEFT JOIN adm_pessoa_endereco AS ape ON ape.pessoa_id = ap.id
            LEFT JOIN adm_cidade          AS ac  ON ac.id = ape.cidade_id
            LEFT JOIN adm_pessoa_telefone AS apt ON apt.pessoa_id = ap.id
            LEFT JOIN financeiro_titulo   AS ft  ON ft.pessoa_id = ap.id
            WHERE fc.id IN %s
            GROUP  BY ap.id,
                      fc.id,
                      ft.pessoa_id
        """ % (cliente_ids)
        cr.execute(sql)
        res = cr.dictfetchall()
        return res

    def ecfuti_get_clientes(self, cr, uid, context=None):
        context = context and context.copy() or {}
        obj_adm_utils = self.pool.get('adm.utils')
        obj_financeiro_titulo = self.pool.get('financeiro.titulo')
        fc_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'financeiro.cliente',
                                                                       context=context)
        cliente_ids = self.pool.get('financeiro.cliente').search(
            cr, uid, [('company_id', '=', fc_company_id)], context=context)
        if not cliente_ids:
            return False, {}

        dados_clientes = self.get_dados_cliente_postgres(cr, cliente_ids)
        list_clientes = []
        clientes_bloqueados = fincli_get_bloqueio(self, cr, uid, cliente_ids, context=context)
        clientes = []
        pessoas_ids = map(lambda i: i.get('pessoa_id'), dados_clientes)
        previsao_ids = self.pool.get('documento.documento.tipo').search(
            cr, uid, [('sigla', '=', 'PRV')], context=context)
        args = [('pessoa_id', 'in', pessoas_ids),
                ('state', '=', 'A'),  # Títulos em aberto
                ('tipo_titulo', '=', 'R'),
                ('doc_tipo_id', 'not in', previsao_ids)]  # Títulos à receber
        titulo_ids = obj_financeiro_titulo.search(cr, uid, args, context=context)
        saldo = obj_financeiro_titulo.read(cr, uid, titulo_ids, ['saldo', 'pessoa_id'],
                                           context=context, load='_classic_write')
        total_em_aberto = self._group_saldo(saldo)
        for cliente in dados_clientes:
            cliente_id = cliente.get('cliente_id')
            if not cliente_id in list_clientes:
                cpf_cnpj = cliente.get('cpf_cnpj')
                try:
                    cpf_cnpj_valido = int(obj_adm_utils.admutl_remove_caracter(
                        cpf_cnpj, letras=False, espaco=False))
                except:
                    cpf_cnpj_valido = False
                if cpf_cnpj_valido and cliente.get('nome'):
                    pessoa_id = cliente.get('pessoa_id')
                    cpf_cnpj = re_sub(r'[^a-zA-Z0-9]', '', cpf_cnpj).rjust(15, '0')
                    # B=Bloqueado, L=Liberado
                    supcli_status = 'B' if clientes_bloqueados.get(cliente_id) != 'L' else 'L'
                    list_clientes.append(cliente_id)
                    cep = cliente.get('cep') or 'null'
                    cep = cep.replace('.', '').replace('-', '')
                    nome = cliente.get('nome')[:40].replace("'", '')
                    nome = obj_adm_utils.admutl_remover_acentuacao(cr, uid, nome)
                    endereco = self.remove_numero_endereco(cliente.get('endereco'))
                    endereco = obj_adm_utils.admutl_remover_acentuacao(cr, uid, endereco)
                    endereco = endereco[:90].replace("'", '')
                    total_aberto = total_em_aberto.get(pessoa_id) or 0
                    limite_compras = cliente.get('limite_credito') or 'null'
                    dif = (cliente.get('limite_credito') or 0) - total_aberto
                    if dif < 0:
                        limite_compras = 0

                    codigo_interno = int(re.sub('[^0-9]', '', str(cliente.get('codigo_interno') or 0)) or 0)
                    ie = cliente.get('admpes_jur_ie') or 'null'
                    ie = ie[:15]
                    bairro = cliente.get('bairro') or 'null'
                    bairro = obj_adm_utils.admutl_remover_acentuacao(cr, uid, bairro)
                    bairro = obj_adm_utils.admutl_remover_acentuacao(cr, uid, bairro[:20]).replace(
                        "'", " ")
                    cidade = cliente.get('cidade') or 'null'
                    cidade = obj_adm_utils.admutl_remover_acentuacao(cr, uid, cidade)
                    cidade = obj_adm_utils.admutl_remover_acentuacao(cr, uid, cidade[:30]).replace("'", '')
                    estado = obj_adm_utils.admutl_remover_acentuacao(cr, uid, cliente.get('uf') or 'null')
                    if estado != 'null':
                        estado = estado[:2]
                    telefone = cliente.get('telefone') or 'null'
                    telefone = telefone[:14]
                    rota = cliente.get('fincli_rota') or 'null'
                    pessoa_tipo = cliente.get('pessoa_tipo')
                    cod_municipio = cliente.get('codigo_ibge') or 'null'
                    numero = cliente.get('endereco') and cliente.get('endereco').split(', ') or ''
                    complemento = ''
                    if len(numero) > 1:
                        dados_numero = numero[1].split('-')
                        numero = dados_numero[0]
                        if len(dados_numero) > 1:
                            complemento = dados_numero[1]
                    else:
                        numero = False
                        complemento = ''

                    complemento = obj_adm_utils.admutl_remover_acentuacao(cr, uid, complemento or 'null')
                    complemento = obj_adm_utils.admutl_remove_caracter(complemento)
                    endereco_numero = obj_adm_utils.admutl_remover_acentuacao(cr, uid,
                                                                              numero or cliente.get(
                                                                                  'numero') or 'null')
                    endereco_numero = endereco_numero[:15]
                    email = cliente.get('email') or 'null'
                    email = email[:100]
                    vals = {'cpf_cnpj': cpf_cnpj,
                            'nome': nome,
                            'supcli_status': supcli_status,
                            'endereco': endereco,
                            'limite_compras': limite_compras,
                            'total_em_aberto': total_em_aberto.get(pessoa_id) or 'null',
                            'codigo_interno': codigo_interno,
                            'ie': ie,
                            'bairro': bairro,
                            'cidade': cidade,
                            'estado': estado,
                            'cep': cep,
                            'telefone': telefone,
                            'rota': rota,
                            'pessoa_tipo': pessoa_tipo,
                            'cod_municipio': cod_municipio,
                            'endereco_numero': endereco_numero.replace("'", ''),
                            'complemento': complemento,
                            'email': email}
                    clientes.append(vals)

        # Criar mensagens de clientes
        msg_clientes = self.ecfuti_get_mensagem_cliente(cr, uid, cliente_ids, context)
        return True, clientes, msg_clientes

    @staticmethod
    def _group_saldo(dados):
        res = {}
        keyfunc = lambda i: i.get('pessoa_id')
        groups = it.groupby(sorted(dados, key=keyfunc), keyfunc)
        for k, g in groups:
            res.update({k: sum(x['saldo'] for x in g)})
        return res

    def _get_dados_mensagens(self, cr, uid, cliente_ids, context=None):
        context = context and context.copy() or {}
        if not cliente_ids:
            return []

        sql = """
            SELECT ap.cpf_cnpj,
                   fcmn.name,
                   fcmn.tipo_mensagem,
                   fcmn.codigo,
                   fcm.modo_exibicao,
                   fc.active
            FROM   adm_pessoa                            AS ap
            INNER JOIN financeiro_cliente                AS fc   ON fc.pessoa_id = ap.id
            INNER JOIN financeiro_clientes_mensagem      AS fcm  ON fcm.cliente_id = fc.id
            INNER JOIN financeiro_clientes_mensagem_nome AS fcmn ON fcmn.id = fcm.mensagens_id
            WHERE fc.id in (%s)
            GROUP  BY ap.cpf_cnpj,
                      fcmn.name,
                      fcmn.tipo_mensagem,
                      fcmn.codigo,
                      ap.write_date,
                      fc.active,
                      fcm.modo_exibicao
        """ % ','.join(map(lambda x: '%s' % x, cliente_ids))
        cr.execute(sql)
        return cr.dictfetchall()

    def ecfuti_get_mensagem_cliente(self, cr, uid, cliente_ids, context=None):
        """
        Cria ou atualiza as mensagens dos clientes na tabela supervisor_cad_mensagens_clientes
        """
        context = context and context.copy() or {}
        if not cliente_ids:
            return []

        obj_adm_utils = self.pool.get('adm.utils')
        dados_mensagem_clientes = self._get_dados_mensagens(cr, uid, cliente_ids, context=context)
        inserts = []
        for msg in dados_mensagem_clientes:
            cnpj_cpf = msg.get('cpf_cnpj') or 'null'
            if cnpj_cpf != 'null':
                cnpj_cpf = re_sub(r'[^a-zA-Z0-9]', '', cnpj_cpf)
                cnpj_cpf = cnpj_cpf[:15]
                sequencia = 0
                mensagem = msg.get('name') or 'null'
                mensagem = obj_adm_utils.admutl_remover_acentuacao(cr, uid, mensagem[:40])
                tipo = msg.get('tipo_mensagem') or 'null'
                tipo = tipo[:1]
                if tipo == 'B':  # nao mostra motivo do bloqueio
                    mensagem = 'Mensagem nro: %s' % msg.get('codigo')


                vals = {'cnpj_cpf': cnpj_cpf,
                        'sequencia': sequencia,
                        'mensagem': mensagem,
                        'tipo': tipo}
                inserts.append(vals)

        return inserts

    def ecfuti_get_left_local_producao(self, context=None):
        """Implementado por heranca no modulo vendas_cozinha"""
        context = context and context.copy() or {}
        return ''

    def ecfuti_get_camp_local_producao(self, context=None):
        """Implementado por heranca no modulo vendas_cozinha"""
        context = context and context.copy() or {}
        return ''

    def ecfuti_get_itens(self, cr, uid, tipo_exportacao, company_id, context=None):
        context = context and context.copy() or {}
        res = {'valor': [], 'mensagem': ''}
        mensagem = ''
        itens = False
        tributacao = False
        parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'estoque',
                                                       ['estpar_super_loja'], company_id=company_id, context=context)
        loja = parametro_dados.get('estpar_super_loja')
        obj_adm_utils = self.pool.get('adm.utils')
        obj_estoque_produto = self.pool.get('estoque.produto')
        ep_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'estoque.produto',
                                                                       user_company_id=company_id,context=context)
        ap_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'automacao.precos',
                                                                       user_company_id=company_id, context=context)
        acb_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'automacao.codigo.barra',
                                                                        user_company_id=company_id,
                                                                        context=context)
        fields_to_read = ['arquivo_de_itens_ecf', 'arquivo_de_trib_ecf', 'arquivo_de_nserie',
                          'estpar_super_local_id', 'estpar_balanca_usar_tara']
        parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'estoque',
                                                               fields_to_read, company_id=company_id, context=context)
        if not parametro_dados:
            raise Exception(_('Parametros de estoque nao encontrados'))

        else:
            estpar_super_local_id = parametro_dados.get('estpar_super_local_id') or []

        camp_produto_de_balanca = ''
        camp_peso_tara = ''
        camp_nserie_tipo = ''

        fields_estoque_produto = self.pool.get('estoque.produto').fields_get(cr, uid,
                                                                             ['produto_de_balanca'])
        if fields_estoque_produto.get('produto_de_balanca'):
            camp_produto_de_balanca += """, ep.produto_de_balanca
                      """

        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'balanca', context=context):
            camp_peso_tara += """, ep.estpro_peso_tara
                      """
        estpro_nserie_tipo = obj_estoque_produto.fields_get(cr, uid, ['estpro_nserie_tipo'])
        if estpro_nserie_tipo.get('estpro_nserie_tipo'):
            camp_nserie_tipo += """, ep.estpro_nserie_tipo
                      """

        modulo_kit_instalado = obj_adm_utils.admutl_check_modulo_instalado(cr, uid, 'kit', context)
        cond_kit_produtos = ''
        cond_autpre_ja_exportou = ''
        cond_local_id = ''
        if modulo_kit_instalado:
            cond_kit_produtos += '''AND coalesce(ep.kit_de_produtos, False) = False'''

        if tipo_exportacao == 'P':
            cond_autpre_ja_exportou += '''AND ap.autpre_ja_exportou = False'''

        if estpar_super_local_id:
            cond_local_id += ("""AND ell.local_id IN (%s) """ % ','.
                              join(map(lambda x: "%s" % x, estpar_super_local_id)))
        camp_local_producao = self.ecfuti_get_camp_local_producao(context)
        sql = """
            SELECT acb.codigo_barra,
                   acb.company_id                               AS company_id,
                   ep.name,
                   ep.origem_mercadoria,
                   ep.active                                    AS produto_ativo,
                   ep.estpro_fator_conversao_unidade_tributavel AS fator_conversao,
                   1                                            AS departamento,
                   ft.tributacao_ecf,
                   epg.name                                     AS descricao,
                   epg.descricao_resumida,
                   (CASE WHEN ep.ncm_id IS NOT NULL
                         THEN fn.codigo
                         ELSE NULL
                    END)                                        AS ncm_codigo,
                   cest.fiscest_codigo                          AS cest_codigo,
                   (CASE WHEN ep.origem_mercadoria IN ('0','3','4','5', '8')
                         THEN fn.fisnc_aliq_ibpt_fed_nac
                         WHEN ep.origem_mercadoria IN ('1','2','6','7')
                         THEN fn.fisnc_aliq_ibpt_fed_imp
                         ELSE NULL
                    END)                                        AS aliquota_tributos_fed,
                   fn.fisnc_aliq_ibpt_est                       AS aliquota_tributos_est,
                   fn.fisnc_aliq_ibpt_mun                       AS aliquota_tributos_mun,
                   fn.fisnc_ibpt_chave                          AS chave_ibpt,
                   fca.fisanp_codigo                            AS codigo_anp,
                   fca.fisanp_adrem                             AS aliq_adrem,
                   fca.fisanp_pglp                              AS pglp, 
                   fca.fisanp_pgnn                              AS pgnn,
                   fca.fisanp_pgni                              AS pgni,
                   fca.fisanp_partida                           AS vpart,
                   eeu.fracao,
                   ap.preco_venda,
                   eeu.unidade,
                   ee.quantidade_na_embalagem,
                   acb.peso_embalagem,
                   ep.codigo                                    AS codigo_retaguarda,
                   ep.producao_propria,
                   ep.id                                        AS produto_id,
                   ep.estpro_med_codigo_anvisa                  AS med_codigo_anvisa,
                   ep.estpro_med_motivo_isencao                 AS med_motivo_isencao,
                   ep.estpro_med_preco_maximo                   AS med_preco_maximo,
                   acb.grade_id,
                   acb.active                                   AS acb_active,
                   acb.autcba_tipo_barra                        AS tipo_gtin,
                   ap.id                                        AS automacao_precos_id,
                   ap.autpre_ja_exportou
                   {camp_produto_de_balanca}
                   {camp_peso_tara}
                   {camp_nserie_tipo}
                   {camp_local_producao}
            FROM automacao_precos                 AS ap
            INNER JOIN automacao_codigo_barra     AS acb  ON acb.id = ap.codigo_barra_id
            INNER JOIN estoque_produto            AS ep   ON ep.id = acb.produto_id
            INNER JOIN estoque_produto_grade      AS epg  ON epg.id = acb.grade_id
            INNER JOIN estoque_produto_embalagem  AS epe  ON epe.id = acb.produto_embalagem_id
            INNER JOIN estoque_embalagem          AS ee   ON ee.id = epe.embalagem_id
            INNER JOIN estoque_embalagem_unidade  AS eeu  ON eeu.id = ee.unidade_id
            INNER JOIN fiscal_tributacao_encargos AS fte  ON fte.produto_id = ep.id
            INNER JOIN fiscal_tributacao          AS ft   ON ft.id = fte.tributacao_id
            INNER JOIN fiscal_ncm                 AS fn   ON fn.id = ep.ncm_id
            LEFT  JOIN fiscal_cest                AS cest ON cest.id = ep.estpro_cest_id
            LEFT  JOIN fiscal_cadastro_anp        AS fca  ON fca.id = ep.estpro_codigo_anp_id 
            INNER JOIN fiscal_encargo             AS fe   ON fe.id = fte.encargo_id
            INNER JOIN estoque_local_locacao      AS ell  ON ell.grade_id = epg.id
            {left_loca_producao}
            WHERE fte.tipo_tributacao = 'T'
              AND fe.sigla IN ('ICMS','ISS')
              AND ap.company_id = {ap_company_id}
              AND acb.company_id = {acb_company_id}
              {cond_kit_produtos}
              {cond_autpre_ja_exportou}
              {cond_local_id}
            ORDER BY acb.codigo_barra
                 """.format(camp_produto_de_balanca=camp_produto_de_balanca,
                            camp_peso_tara=camp_peso_tara,
                            camp_nserie_tipo=camp_nserie_tipo,
                            ap_company_id=ap_company_id,
                            acb_company_id=acb_company_id,
                            cond_kit_produtos=cond_kit_produtos,
                            cond_autpre_ja_exportou=cond_autpre_ja_exportou,
                            cond_local_id=cond_local_id,
                            left_loca_producao=self.ecfuti_get_left_local_producao(context),
                            camp_local_producao=camp_local_producao)
        cr.execute(sql)
        dados_produtos = cr.dictfetchall()
        if modulo_kit_instalado:
            campos_kit = ''
            condicao_kit = ''
            if obj_adm_utils.admutl_check_modulo_instalado(cr, uid, 'balanca', context):
                campos_kit += ''', ep.estpro_peso_tara '''
            if tipo_exportacao == 'P':
                condicao_kit += '''AND ap.autpre_ja_exportou = False'''

            sql_kit = """SELECT DISTINCT(acb.codigo_barra),
                                acb.company_id          AS company_id,
                                ep.name,
                                ep.origem_mercadoria,
                                CASE WHEN (SELECT COUNT(epe2.id)
                                           FROM estoque_produto AS epe2 
                                           WHERE epe2.id = kp.kitpro_item_produto_id
                                             AND epe2.active = False) > 0 
                                     THEN FALSE 
                                     ELSE ep.active  
                                END                     AS produto_ativo,
                                ep.grade_usar,
                                ft.tributacao_ecf,
                                epg.name                AS descricao,
                                epg.descricao_resumida,
                                acb.active              AS acb_active,
                                ep.kit_de_produtos,
                                acb.peso_embalagem,
                                ap.id                   AS automacao_precos_id,
                                ap.preco_venda,
                                ap.autpre_ja_exportou,
                                ep.producao_propria,
                                ep.codigo               AS codigo_retaguarda,
                                fca.fisanp_codigo       AS codigo_anp,
                                fca.fisanp_adrem        AS aliq_adrem,
                                fca.fisanp_pglp         AS pglp, 
                                fca.fisanp_pgnn         AS pgnn,
                                fca.fisanp_pgni         AS pgni,
                                fca.fisanp_partida      AS vpart,
                                ep.id                   AS produto_id,
                                acb.grade_id,
                                fn.codigo               AS ncm_codigo,
                                cest.fiscest_codigo     AS cest_codigo,
                                (CASE WHEN ep.origem_mercadoria IN ( '0', '3', '4', '5', '8' )
                                      THEN fn.fisnc_aliq_ibpt_fed_nac
                                      WHEN ep.origem_mercadoria IN ( '1', '2', '6', '7' )
                                      THEN fn.fisnc_aliq_ibpt_fed_imp
                                      ELSE NULL
                                  END )                 AS aliquota_tributos_fed,
                                fn.fisnc_aliq_ibpt_est  AS aliquota_tributos_est,
                                fn.fisnc_aliq_ibpt_mun  AS aliquota_tributos_mun,
                                fn.fisnc_ibpt_chave     AS chave_ibpt,
                                eeu.fracao,
                                eeu.unidade,
                                ee.quantidade_na_embalagem
                                {campos_kit}
                                {camp_produto_de_balanca}
                                {camp_peso_tara}
                         FROM kit_produto                      AS kp
                         INNER JOIN estoque_produto            AS ep   ON ep.id = kp.kitpro_produto_id
                         INNER JOIN automacao_codigo_barra     AS acb  ON acb.produto_id = kp.kitpro_produto_id
                         INNER JOIN estoque_produto_grade      AS epg  ON acb.grade_id = epg.id
                         INNER JOIN estoque_produto_embalagem  AS epe  ON epe.id = acb.produto_embalagem_id
                         INNER JOIN estoque_embalagem          AS ee   ON ee.id = epe.embalagem_id
                         INNER JOIN estoque_embalagem_unidade  AS eeu  ON eeu.id = ee.unidade_id
                         INNER JOIN fiscal_tributacao_encargos AS fte  ON fte.produto_id = ep.id
                         INNER JOIN fiscal_tributacao          AS ft   ON ft.id = fte.tributacao_id
                         INNER JOIN fiscal_ncm                 AS fn   ON fn.id = ep.ncm_id
                         INNER JOIN fiscal_encargo             AS fe   ON fe.id = fte.encargo_id
                         LEFT  JOIN fiscal_cest                AS cest ON cest.id = ep.estpro_cest_id
                         LEFT  JOIN fiscal_cadastro_anp        AS fca  ON fca.id = ep.estpro_codigo_anp_id 
                         INNER JOIN automacao_precos           AS ap   ON ap.codigo_barra_id = acb.id
                         WHERE ep.company_id = {ep_company_id}
                           AND ap.company_id = {ap_company_id}
                           AND acb.company_id = {acb_company_id}
                           AND fte.tipo_tributacao = 'T'
                           AND fe.sigla IN ('ICMS','ISS')
                           {condicao_kit}
                         ORDER BY acb.codigo_barra """.format(campos_kit=campos_kit,
                                                              camp_produto_de_balanca=camp_produto_de_balanca,
                                                              camp_peso_tara=camp_peso_tara,
                                                              ap_company_id=ap_company_id,
                                                              acb_company_id=acb_company_id,
                                                              ep_company_id=ep_company_id,
                                                              condicao_kit=condicao_kit)
            cr.execute(sql_kit)
            res_kits = cr.dictfetchall()
            for res_kit in res_kits:
                dados_produtos.append(res_kit)

        auto_ids = []
        produto_ids = []
        for i in dados_produtos:
            auto_ids.append(i.get('automacao_precos_id'))
            produto_ids.append('%s' % i.get('produto_id'))

        usa_tara = False
        if obj_adm_utils.admutl_check_modulo_instalado(cr, uid, 'balanca', context):
            usa_tara = parametro_dados.get('estpar_balanca_usar_tara')

        inserts = list()
        codigo_barra_company = dict()
        sql = """
            SELECT ft.id                  AS codigo_trib,
                   ft.aliquota            AS aliquota,
                   ft.base                AS base,
                   ft.fistri_aliquota_fcp AS aliquota_fcp,
                   fc.tipo                AS tipo_tributacao,
                   fc.codigo              AS codigo_cst,
                   fe.sigla               AS encargo,
                   csosn2.codigo          AS csosn_nao,
                   fte.produto_id         AS produto_id

            FROM fiscal_tributacao                AS ft  
            INNER JOIN fiscal_tributacao_encargos AS fte    ON fte.tributacao_id = ft.id 
            INNER JOIN fiscal_encargo             AS fe     ON fe.id = fte.encargo_id
            INNER JOIN fiscal_cst                 AS fc     ON fc.id = fte.cst_id
            LEFT JOIN fiscal_csosn                AS csosn2 ON csosn2.id = fc.fiscst_csosn_nao_contribuinte_id
            WHERE fte.tipo_tributacao = 'T' -- 'T' = Todas/Consumidor Final
              AND fte.produto_id IN (%s)
              AND fe.sigla IN ('PIS','COFINS','ICMS','ISS')
              """ % ','.join(produto_ids)
        dados_trib_nfce = []
        if produto_ids:
            cr.execute(sql)
            dados_trib_nfce = cr.dictfetchall()

        dict_encargos = {'PIS': 'P', 'COFINS': 'C', 'ICMS': 'I', 'ISS': 'S'}
        vals_trib = []
        for i in dados_trib_nfce:
            codigo_trib = i.get('codigo_trib')
            csosn = 'null'
            if i.get('csosn_nao'):
                csosn = "'%s'" % i.get('csosn_nao')

            vals_trib.append({'suptnf_codigo': codigo_trib,
                              'suptnf_aliquota': i.get('aliquota') or 0,
                              'suptnf_base': i.get('base') or 0,
                              'suptnf_aliquota_fcp': i.get('aliquota_fcp') or 0,
                              'suptnf_encargo': dict_encargos.get(i.get('encargo')),
                              'suptnf_codigo_cst': i.get('codigo_cst'),
                              'suptnf_codigo_csosn': csosn,
                              'suptnf_tipo_tributacao': i.get('tipo_tributacao'),
                              'suptnf_motivo_beneficio': '9',
                              'produto_id': i.get('produto_id'),
                              'encargo': i.get('encargo')})

        codigo_itens = []
        msg_sem_preco = []
        msg_sem_ncm = []
        msg_sem_cest = []
        msg_preco_invalido = []
        msg_anp = []
        vals_itens = []
        for produto in dados_produtos:
            key_cb_company = str(produto.get('company_id')) + '-' + produto.get('codigo_barra')
            if codigo_barra_company.get(key_cb_company):
                continue

            name_completo = produto.get('descricao') or 'null'
            name_completo = name_completo.replace("'", '')
            supite_descricao_completa = obj_adm_utils.admutl_remover_acentuacao(cr, uid, name_completo[:60])
            supite_codigo_item = produto.get('codigo_barra') or 'null'
            supite_codigo_item = supite_codigo_item[:14]
            codigo_barra_company[key_cb_company] = True
            itens = True
            supite_loja = loja
            supite_codigo_retaguarda = produto.get('codigo_retaguarda') or 'null'
            codigo_itens.append(supite_codigo_item)
            supite_fator_multiplicador = produto.get('fator_conversao') or 1
            name = produto.get('descricao_resumida') or produto.get('descricao') or 'null'
            name = name.replace("'", '')
            name = obj_adm_utils.admutl_remover_acentuacao(cr, uid, name)[:30]
            supite_pesavel = produto.get('produto_de_balanca') or 'null'
            supite_fracionado = produto.get('fracao') or 'null'
            supite_unidade = obj_adm_utils.admutl_remover_acentuacao(cr, uid, produto.get('unidade') or 'null')
            supite_peso_da_embalagem = produto.get('peso_embalagem') or 'null'
            supite_codigo_local = ''
            if camp_local_producao:
                supite_codigo_local = " '%s'" % (produto.get('codigo_local_producao') or 'null')

            supite_peso_tara = 'null'
            if usa_tara:
                supite_peso_tara = produto.get('estpro_peso_tara') or 'null'

            supite_producao = produto.get('producao_propria') and 'P' or 'T'
            supite_iat = 'A'
            supite_cest = 'null'
            tem_msg = False
            if not produto.get('ncm_codigo') and produto.get('produto_ativo') :
                msg_sem_ncm.append('\n%s - %s' % (supite_descricao_completa, supite_codigo_item))
                tem_msg = True

            supite_preco = produto.get('preco_venda')
            if not supite_preco:
                msg_sem_preco.append('\n%s - %s' % (supite_descricao_completa, supite_codigo_item))
                tem_msg = True

            elif supite_preco > 10000000 or len(("%s" % (supite_preco * 100)).split('.')) > 1 and \
                    int(("%s" % (supite_preco * 100)).split('.')[1]) >= 1:
                msg_preco_invalido.append(_('\n%s - %s Preco invalido') %
                                          (supite_descricao_completa, supite_codigo_item))
                tem_msg = True

            if produto.get('codigo_anp') == '210203001':
                if (produto.get('pglp') or 0) + (produto.get('pgnn') or 0) + \
                        (produto.get('pgni') or 0) < 100:
                    msg_anp.append(_('%s - %s') % (supite_descricao_completa, supite_codigo_item))
                    tem_msg = True

            supite_ncm = produto.get('ncm_codigo') and (produto.get('ncm_codigo')).ljust(8, '0') or ''
            if produto.get('cest_codigo'):
                supite_cest = f_txt(produto.get('cest_codigo'), 7)

            active = produto.get('produto_ativo') or False
            if active:
                if not produto.get('acb_active') or produto.get('acb_active') == 'F':
                    active = False

            if tem_msg:
                continue

            supite_aliquota_ibpt_fed = produto.get('aliquota_tributos_fed') or 0.0
            supite_aliquota_ibpt_est = produto.get('aliquota_tributos_est') or 0.0
            supite_aliquota_ibpt_mun = produto.get('aliquota_tributos_mun') or 0.0
            supite_ibpt_chave = produto.get('chave_ibpt') or ''
            tributacao_ecf = produto.get('tributacao_ecf') or ''
            dict_item = {'produto_id': produto.get('produto_id'),
                               'tributacao_ecf': tributacao_ecf,
                               'supite_loja': supite_loja,
                               'supite_codigo_retaguarda': supite_codigo_retaguarda,
                               'supite_codigo_item': supite_codigo_item,
                               'name': name,
                               'origem_mercadoria': produto.get('origem_mercadoria') or 'null',
                               'supite_getin': produto.get('tipo_gtin') != 'OT',
                               'supite_med_codigo_anvisa': produto.get('med_codigo_anvisa') or 'null',
                               'supite_med_motivo_isencao': produto.get('med_motivo_isencao') or 'null',
                               'supite_med_preco_maximo': produto.get('med_preco_maximo') or 0,
                               'supite_codigo_anp': int((produto.get('codigo_anp') or '').replace(' ', '') or 0) or 'null',
                               'supite_adrem': produto.get('aliq_adrem') or 0,
                               'supite_pglp': produto.get('pglp') or 0,
                               'supite_pgnn': produto.get('pgnn') or 0,
                               'supite_pgni': produto.get('pgni') or 0,
                               'supite_vpart': produto.get('vpart') or 0,
                               'supite_pesavel': supite_pesavel,
                               'supite_fracionado': supite_fracionado,
                               'supite_unidade': supite_unidade,
                               'supite_peso_da_embalagem': supite_peso_da_embalagem,
                               'supite_peso_tara': supite_peso_tara,
                               'supite_producao': supite_producao,
                               'supite_iat': supite_iat,
                               'supite_ncm': supite_ncm,
                               'supite_cest': supite_cest,
                               'supite_preco': supite_preco,
                               'active': active,
                               'supite_aliquota_ibpt_fed': supite_aliquota_ibpt_fed,
                               'supite_aliquota_ibpt_est': supite_aliquota_ibpt_est,
                               'supite_aliquota_ibpt_mun': supite_aliquota_ibpt_mun,
                               'supite_ibpt_chave': supite_ibpt_chave,
                               'supite_descricao_completa': supite_descricao_completa,
                               'supite_fator_multiplicador': supite_fator_multiplicador,
                               'supite_codigo_local': supite_codigo_local or 'null'}
            vals_itens.append(dict_item)
            tributacao = True

        if dados_produtos and auto_ids:
            vals_automacao = {'autpre_ja_exportou': True}
            self.pool.get('automacao.precos').write(cr, uid, auto_ids, vals_automacao, context=context)

        msg = ''
        if not itens or not vals_itens:
            msg += _('\nNao ha itens para importacao.') + '\n' + ''.ljust(120, '-') + '\n'

        if msg_sem_preco:
            msg += _('\nOs itens abaixo nao possuem preco: %s') % ''.join(msg_sem_preco)\
                    + '\n' + ''.ljust(120, '-') + '\n'

        if msg_preco_invalido:
            msg += _('\nOs itens abaixo possuem preco invalido: %s') % ''.join(msg_preco_invalido)\
                    + '\n' + ''.ljust(120, '-') + '\n'

        if msg_sem_ncm:
            msg += _('\nOs itens abaixo nao possuem NCM: %s') % ''.join(msg_sem_ncm)\
                    + '\n' + ''.ljust(120, '-') + '\n'

        if msg_sem_cest:
            msg += _('\nOs itens abaixo nao possuem CEST: %s') % ''.join(msg_sem_cest)\
                    + '\n' + ''.ljust(120, '-') + '\n'

        if msg_anp:
            msg += _('\n Somatorio percentuais de GLP derivado do petroleo,'
                     ' GLGNn e GLGNi diferente de 100\n%s') % '\n'.join(msg_anp)\
                    + '\n' + ''.ljust(120, '-') + '\n'

        if mensagem:
            msg += _('\nOs itens abaixo nao foram importados. Verifique a Tributacao na '
                     'ECF para os tributos dos itens. Verifique o cadastro de '
                     'tributacao no supervisor.') + mensagem\
                    + '\n' + ''.ljust(120, '-') + '\n'
        if msg:
            res['mensagem'] = msg

        if itens and tributacao:
            res['valor'] = [vals_itens, vals_trib]

        return res

    def ecfuti_exportar_dados(self, cr, uid, dados, company_id, context=None):
        context = context and context.copy() or {}
        res = self.pool.get('res.users').search(cr, uid, [('login', '=', 'admin')])
        if res:
            uid = res[0]

        log_info_exp = ''
        values_exportacao = {}

        # OBJETOS
        obj_estoque_parametro = self.pool.get('estoque.parametro')

        # DADOS DO ESTOQUE_PARAMETRO
        estpar_fields_to_read = [
            'estpar_tipo_exportacao', 'arquivo_de_itens_ecf', 'arquivo_de_trib_ecf',
            'arquivo_de_clientes',
            'arquivo_de_vendedores', 'arquivo_de_kit', 'estpar_super_local_id', 'company_id']
        estpar_dados = obj_estoque_parametro.estpar_get_fields(
            cr, uid, fields_to_read=estpar_fields_to_read, context=context
        )
        if isinstance(estpar_dados, list):
            estpar_dados = estpar_dados[0]

        estpar_local_ids = estpar_dados.get('estpar_super_local_id')
        kit_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'kit', context=context)
        expo_gerar_kit = dados.get('kits')
        expo_gerar_itens = dados.get('itens')
        expo_gerar_clientes = dados.get('clientes')
        expo_gerar_vendedores = dados.get('vendedores')
        expo_exportar_saldo = dados.get('saldo')
        tipo_exportacao = dados.get('tipo_exportacao')
        if expo_gerar_itens:
            try:
                resultado = self.ecfuti_get_itens(cr, uid, tipo_exportacao, company_id,
                                                  context=context)
            except Exception as e:
                return False, str(e)

            if resultado.get('valor'):
                values_exportacao['itens'] = resultado.get('valor')[0]
                values_exportacao['tributacoes'] = resultado.get('valor')[1]

            if resultado.get('mensagem'):
                log_info_exp += resultado.get('mensagem')

        if expo_gerar_kit and kit_instalado:
            try:
                msg, vals_kit = self.ecfuti_get_kit(cr, uid, company_id, context=context)
            except Exception as e:
                return False, str(e)

            values_exportacao['kits'] = {'vals': vals_kit or False,
                                         'msg': '\n'.join(msg or [])}

        if expo_gerar_clientes:
            resultado, clientes, msg_clientes = self.ecfuti_get_clientes(cr, uid, context=context)
            if resultado:
                log_info_exp += _('\n%s Clientes Importados.' % len(clientes)) + '\n' + ''.ljust(120, '-') + '\n'
                values_exportacao['clientes'] = clientes
                values_exportacao['msg_clientes'] = msg_clientes
            else:
                log_info_exp += _('\nNenhum cliente Importado.') + '\n' + ''.ljust(120, '-') + '\n'

        if expo_gerar_vendedores:
            msg, resultado = self.ecfuti_get_vendedores(cr)
            if resultado:
                values_exportacao['vendedores'] = resultado

            log_info_exp += msg

        if dados.get('locais'):
            dados_locais = self.ecfuti_get_locais_producao(cr, uid, dados.get('locais'),
                                                           dados.get('n_locais'), context=context)
            if dados_locais:
                values_exportacao['locais_producao'] = dados_locais
                log_info_exp += _('\nLocais de Producao Importados.')
            else:
                log_info_exp += _('\nNenhum Local de Producao Importado.')

        if expo_exportar_saldo:
            self.ecfuti_atualiza_saldo(cr, uid, company_id, estpar_local_ids, context)
            log_info_exp += _('Saldos atualizados! Aguardando o cron do Supervisor fazer a importacao!')

        values_exportacao['msg'] = log_info_exp
        return values_exportacao, ''

    def ecfuti_get_locais_producao(self, cr, uid, pegar_locais, n_locais, context=None):
        '''Implementado por heranca no modulo vendas_cozinha'''
        return False

    def ecfuti_atualiza_saldo(self, cr, uid, company_id, local_ids, context=None):
        """
        Este metodo tem a funcao de gerar uma carga total do saldo dos produtos existentes na
        tabela automacao_codigo_barra, e alimentar a tabela ecf_exportar_saldo_super (CH-85605)

        :param cr: a Vinha atual do cursor do banco de dados
        :param uid: ID do usuario que gerou esta exportacao
        :param company_id: ID da empresa que o usuario esta lagado
        :param local_ids: Lista de ids dos locais cadastrados para o atributo estpar_local_id
        do parametro do estoque (estoque.parametro)
        :param context: Dicionario padrao para valores contextuais
        :type cr: cursor
        :type uid: int
        :type company_id: int
        :type local_ids: list
        :type context: dict
        :author: Thiago Abreu Rodrigues <thiago.rodrigues[at]siginformatica.com.br>
        """
        context = context and context.copy() or {}
        obj_aut_cod_barra = self.pool.get('automacao.codigo.barra')
        obj_produto_saldo = self.pool.get('estoque.produto.saldo')
        obj_exp_saldo_super = self.pool.get('ecf.exportar.saldo.super')
        automacao_cob_bar_ids = obj_aut_cod_barra.search(cr, uid, [], context=context)
        fields_to_read = ['grade_id', 'produto_id']
        dados_cod_barras = obj_aut_cod_barra.read(cr, uid, automacao_cob_bar_ids, fields_to_read,
                                                  context=context, load='_classic_write')
        hoje = datetime.today()
        grade_ids = map(lambda i: i.get('grade_id'), dados_cod_barras)
        context.update()
        context_atualiza = context.copy()
        context_atualiza.update({'exporta_saldo_inicial': True,
                                 'ecfexp_exp_total_saldo': True})

        for local_id in local_ids:
            dados_saldo = obj_produto_saldo.get_saldo_do_dia(cr, uid, grade_ids, hoje,
                                                             eps_local_id=local_id, context=context)
            grades_saldo = {}
            map(lambda x: grades_saldo.update({x: dados_saldo.get(x).get('disponivel')}),
                dados_saldo.keys())

            obj_exp_saldo_super.ecfess_atualizar_registros(cr, uid, company_id, local_id,
                                                           grades_saldo,
                                                           context=context_atualiza)
        return True

    def ecfuti_get_saldo(self, cr, uid, dados, company_id, context=None):
        context = context and context.copy() or {}
        sql = """
                    SELECT
                        company_id,
                        estpar_super_host,
                        estpar_super_db,
                        estpar_super_user,
                        estpar_super_password,
                        estpar_super_loja
                    FROM
                        estoque_parametro
                    WHERE estpar_super_host IS NOT NULL
                      AND estpar_super_db IS NOT NULL
                      AND estpar_super_user IS NOT NULL
                      AND company_id = %s
                """ % company_id
        cr.execute(sql)
        parametro = cr.dictfetchall()[0]
        loja = parametro.get('estpar_super_loja')
        company_id = parametro.get('company_id')
        context_saldo = context.copy()
        context_saldo['sig_force_company'] = True
        obj_exporta_saldo = self.pool.get('ecf.exportar.saldo.super')
        exportacao_saldo_supervisor_ids = obj_exporta_saldo.search(cr, uid, [('ecfess_loja', '=', loja),
                                                                ('company_id', '=', company_id)],
                                                      context=context_saldo)
        if not exportacao_saldo_supervisor_ids:
            return []

        exportacao_dados = obj_exporta_saldo.read(cr, uid, exportacao_saldo_supervisor_ids,
                                     ['ecfess_loja', 'ecfess_codigo_barra', 'ecfess_saldo',
                                      'ecfess_exporta_saldo_inicial'], context=context)

        list_vals = []
        for i in exportacao_dados:
            loja = i.get('ecfess_loja')
            codbarra = str(i.get('ecfess_codigo_barra') or '')
            saldo = i.get('ecfess_saldo') or 0
            saldo = saldo if saldo >= 0 else 0
            vals = {'loja': loja,
                    'item': codbarra,
                    'saldo': saldo,
                    'saldo_inicial': saldo}
            list_vals.append(vals)

        if not list_vals:
            return []

        str_ids = ','.join(map(lambda x: str(x), exportacao_saldo_supervisor_ids))
        sql_delete = """DELETE FROM ecf_exportar_saldo_super 
                        WHERE id IN (%s) 
                           AND company_id = %s;
                        COMMIT;""" % (str_ids, company_id)
        try:
            cr.execute(sql_delete)
        except:  # pode ser que o registro ja foi deletado pela exportacao, entao nao faz nada
            pass

        return list_vals

    @staticmethod
    def remove_numero_endereco(endereco):
        try:
            endereco = endereco.split(',')
            endereco.remove(endereco[1])
            return " ".join(endereco)[:40]
        except:
            return "null"
