# -*- coding: utf-8 -*-

import openerp.addons.web.http as http
from logging import getLogger
from openerp.tools import config
from SigUtils.sigerp import db_sig
from SigUtils import cpf, cnpj, datas, numero
import xmlrpclib
from ..valida.controller import MySock as Ms
import json
from logging import getLogger
_logger = getLogger("Ecf")


class MySock(Ms):
    def execute(self, model, function, *args):
        try:
            return self.sock.execute(self.db, self.uid, self.pwd, 'ecf.utils',
                                     'ecfuti_get_funcao', model, function, *args)
        except Exception as e:
            if type(e) == xmlrpclib.Fault:
                msg_erro = e.faultString
                if e.faultCode == 'AccessDenied':
                    msg_erro = 'Erro: %s' % "Acesso ao ERP negado para este Usuário e Senha!"
                elif '9999\n' in e.faultCode:
                    msg_erro = e.faultCode.split('9999\n')[1]
                raise Exception(msg_erro)

            if 'message' in dir(e):
                msg_erro = e.message
            else:
                msg_erro = str(e)
            raise Exception(msg_erro)

SEM_ERRO = '00'
ERRO_CONEXAO = '01'
ERRO_GET_DADOS = '10'
ERRO_INTERNO = '99'


class sc(http.Controller):
    _cp_path = '/ecf'

    @http.httprequest
    def ecf_controller_exportar_dados(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        try:
            sock = MySock(req.params)
            if not req.params.get('company_id'):
                return json.dumps({'codigo': ERRO_INTERNO,
                                   'mensagem': 'Informar uma empresa na configuracao do supervisor',
                                   'retorno': []})
            dados = eval(req.params.get('dados'))[0]
            company_id = int(req.params.get('company_id'))
            res, msg = sock.execute('ecf.utils', 'ecfuti_exportar_dados', dados, company_id)
            if not res:
                return json.dumps({'codigo': ERRO_GET_DADOS,
                                   'mensagem': msg,
                                   'retorno': []})

            return json.dumps({'codigo': SEM_ERRO,
                               'mensagem': 'ok',
                               'retorno': [res]})

        except Exception as e:
            return json.dumps({'codigo': ERRO_INTERNO,
                               'mensagem': 'Erro: %s' % e,
                               'retorno': []})

    @http.httprequest
    def ecf_get_saldos(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        try:
            sock = MySock(req.params)
            if not req.params.get('company_id'):
                return json.dumps({'codigo': ERRO_INTERNO,
                                   'mensagem': 'Informar uma empresa na configuracao do supervisor',
                                   'retorno': []})
            dados = eval(req.params.get('dados'))
            company_id = int(req.params.get('company_id'))
            res = sock.execute('ecf.utils', 'ecfuti_get_saldo', dados, company_id)
            return json.dumps({'codigo': SEM_ERRO,
                               'mensagem': 'ok',
                               'retorno': res})

        except Exception as e:
            return json.dumps({'codigo': ERRO_INTERNO,
                               'mensagem': 'Erro: %s' % e,
                               'retorno': []})