# -*- coding: utf-8 -*-
#
# OBS: para funcionar eh preciso que tenha a pasta 'static' dentro do modulo

import openerp.addons.web.http as http
from ..valida.controller import MySock as Ms
import json
import xmlrpclib, socket
from logging import getLogger
_logger = getLogger("EstoquePedidos")

SEM_ERRO = '00'
ERRO_CONEXAO = '01'
ERRO_CONFIGURACAO = '02'
ERRO_INTERNO = '99'


class MySock(Ms):
    def execute(self, model, function, *args):
        return self.sock.execute(self.db, self.uid, self.pwd, 'valida.utils',
                                 'valuti_get_funcao', model, function, *args)


class sc_estoquepedidos(http.Controller):
    _cp_path = '/estoquepedidos'

    @http.httprequest
    def teste(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        ip = req.httprequest.environ.get('REMOTE_ADDR')
        print ip
        return json.dumps({'codigo': SEM_ERRO,
                           'mensagem': 'ok',
                           'retorno': [ip]})

    @http.httprequest
    def ctrl_estped_get_emrpesa(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        try:
            sock = MySock(req.params)
            res = sock.execute('adm.empresa.objeto',
                               'getEmpresa', 'estoquepedidos.pedido.capa', False, {},
                               int(req.params.get('empresa')))
            return json.dumps({'codigo': SEM_ERRO,
                               'mensagem': '',
                               'retorno': [res]})

        except Exception as e:
            return json.dumps({'codigo': ERRO_CONEXAO,
                               'mensagem': 'Erro: %s' % e,
                               'retorno': [],
                               })

    @http.httprequest
    def ctrl_estped_get_pedidos(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        try:
            sock = MySock(req.params)
            args = eval(req.params.get('args'))
            context = {}
            if req.params.get('empresa'):
                context['sig_force_company'] = int(req.params.get('empresa'))

            res = sock.execute('estoquepedidos.pedido.capa', 'search', args, 0, '',
                               '', context)
            if not res:
                return json.dumps({'codigo': SEM_ERRO,
                                   'mensagem': '',
                                   'retorno': []})

            campos = eval(req.params.get('campos'))
            res = sock.execute('estoquepedidos.pedido.capa', 'read', res, campos)
            return json.dumps({'codigo': SEM_ERRO,
                               'mensagem': '',
                               'retorno': res})

        except Exception as e:
            return json.dumps({'codigo': ERRO_CONEXAO,
                               'mensagem': 'Erro: %s' % e,
                               'retorno': [],
                               })

    @http.httprequest
    def ctrl_estped_get_itens(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        try:
            sock = MySock(req.params)
            args = eval(req.params.get('args'))
            campos = eval(req.params.get('campos'))
            item_ids = sock.execute('estoquepedidos.pedido.item', 'search', args)
            if not item_ids:
                return json.dumps({'codigo': SEM_ERRO,
                                   'mensagem': '',
                                   'retorno': []})

            res = {}
            for i in sock.execute('estoquepedidos.pedido.item', 'read', item_ids, campos):
                if not res.get(i.get('pedido_id')[0]):
                    res[i.get('pedido_id')[0]] = [i]
                else:
                    res[i.get('pedido_id')[0]].append(i)

            return json.dumps({'codigo': SEM_ERRO,
                               'mensagem': '',
                               'retorno': [res]})

        except Exception as e:
            return json.dumps({'codigo': ERRO_CONEXAO,
                               'mensagem': 'Erro: %s' % e,
                               'retorno': [],
                               })

    @http.httprequest
    def ctrl_estped_get_acb(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        try:
            sock = MySock(req.params)
            args = eval(req.params.get('args'))
            empresa = int(req.params.get('empresa'))
            campos = eval(req.params.get('campos'))
            res = sock.execute('automacao.codigo.barra', 'search', args, 0, '', '',
                               {'sig_force_company': empresa})
            if not res:
                return json.dumps({'codigo': SEM_ERRO,
                                   'mensagem': '',
                                   'retorno': []})

            res = sock.execute('automacao.codigo.barra', 'read', res, campos, {}, '_classic_write')
            return json.dumps({'codigo': SEM_ERRO,
                               'mensagem': '',
                               'retorno': res})

        except Exception as e:
            return json.dumps({'codigo': ERRO_CONEXAO,
                               'mensagem': 'Erro: %s' % e,
                               'retorno': [],
                               })

    @http.httprequest
    def ctrl_estped_get_qtd_embalagem(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        try:
            sock = MySock(req.params)
            campos = eval(req.params.get('campos'))
            ids = eval(req.params.get('emb_id'))
            load = '_classic_write'
            embalagem_data = sock.execute('estoque.produto.embalagem', 'read', ids, campos, {}, load)
            embalagem_id = embalagem_data.get('embalagem_id')
            emb = sock.execute('estoque.embalagem', 'read', embalagem_id, 
                               ['quantidade_na_embalagem', 'sigla', 'unidade_id'], {}, load)
            unidade_id = emb.get('unidade_id')
            unidade = sock.execute('estoque.embalagem.unidade', 'read', unidade_id, ['unidade'])
            res = {'qtda': emb.get('quantidade_na_embalagem') or 1, 'sigla': unidade.get('unidade')}
            return json.dumps({'codigo': SEM_ERRO,
                               'mensagem': '',
                               'retorno': [res]})

        except Exception as e:
            return json.dumps({'codigo': ERRO_CONEXAO,
                               'mensagem': 'Erro: %s' % e,
                               'retorno': [],
                               })

    @http.httprequest
    def ctrl_estped_get_cpf(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        try:
            sock = MySock(req.params)
            pessoa_id = int(req.params.get('pessoa_id') or 0)
            if not pessoa_id:
                json.dumps({'codigo': SEM_ERRO,
                            'mensagem': '',
                            'retorno': []})

            res = sock.execute('adm.pessoa', 'read', pessoa_id, ['cpf_cnpj'])
            return json.dumps({'codigo': SEM_ERRO,
                               'mensagem': '',
                               'retorno': [res.get('cpf_cnpj')]})

        except Exception as e:
            return json.dumps({'codigo': ERRO_CONEXAO,
                               'mensagem': 'Erro: %s' % e,
                               'retorno': [],
                               })

    @http.httprequest
    def ctrl_estped_get_fechamentos(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        try:
            sock = MySock(req.params)
            args = eval(req.params.get('args'))
            res = sock.execute('estoquepedidos.pedido.condicao', 'search', args, 0, '', 'id')
            if not res:
                return json.dumps({'codigo': SEM_ERRO,
                                   'mensagem': '',
                                   'retorno': []})

            campos = eval(req.params.get('campos'))
            res = sock.execute('estoquepedidos.pedido.condicao', 'read', res, campos)
            return json.dumps({'codigo': SEM_ERRO,
                               'mensagem': '',
                               'retorno': res})

        except Exception as e:
            return json.dumps({'codigo': ERRO_CONEXAO,
                               'mensagem': 'Erro: %s' % e,
                               'retorno': [],
                               })

    @http.httprequest
    def ctrl_estped_get_cond_forma(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        try:
            sock = MySock(req.params)
            condicao_forma_id = int(req.params.get('condicao_forma_id'))
            res = sock.execute('adm.condicao.forma', 'read', condicao_forma_id, [])
            return json.dumps({'codigo': SEM_ERRO,
                               'mensagem': '',
                               'retorno': [res]})

        except Exception as e:
            return json.dumps({'codigo': ERRO_CONEXAO,
                               'mensagem': 'Erro: %s' % e,
                               'retorno': [],
                               })

    @http.httprequest
    def ctrl_estped_get_parcelas(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        try:
            sock = MySock(req.params)
            args = eval(req.params.get('args'))
            res = sock.execute('estoquepedidos.pedido.parcela', 'search', args, 0, '',
                               'data_vencimento')
            if not res:
                return json.dumps({'codigo': SEM_ERRO,
                                   'mensagem': '',
                                   'retorno': []})

            campos = eval(req.params.get('campos'))
            res = sock.execute('estoquepedidos.pedido.parcela', 'read', res, campos)
            return json.dumps({'codigo': SEM_ERRO,
                               'mensagem': '',
                               'retorno': res})

        except Exception as e:
            return json.dumps({'codigo': ERRO_CONEXAO,
                               'mensagem': 'Erro: %s' % e,
                               'retorno': [],
                               })

    @http.httprequest
    def ctrl_estped_atualiza_pedidos(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        try:
            sock = MySock(req.params)
            pedido_ids = eval(req.params.get('pedido_ids'))
            vals = eval(req.params.get('vals') or '{}')
            sock.execute('estoquepedidos.pedido.capa', 'write', pedido_ids, vals)
            return json.dumps({'codigo': SEM_ERRO,
                               'mensagem': '',
                               'retorno': []})

        except Exception as e:
            return json.dumps({'codigo': ERRO_CONEXAO,
                               'mensagem': 'Erro: %s' % e,
                               'retorno': [],
                               })

    @http.httprequest
    def ctrl_estped_deleta_titulos(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        try:
            sock = MySock(req.params)
            pedido_id = eval(req.params.get('pedido_id'))

            titulo_ids = sock.execute('financeiro.titulo', 'search', [('fintit_pedido_id', '=', pedido_id)])
            sock.execute('financeiro.titulo', 'unlink', titulo_ids)
            return json.dumps({'codigo': SEM_ERRO,
                               'mensagem': '',
                               'retorno': []})

        except Exception as e:
            return json.dumps({'codigo': ERRO_CONEXAO,
                               'mensagem': 'Erro: %s' % e,
                               'retorno': [],
                               })