# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from datetime import datetime
from openerp.tools.translate import _
import copy


class fiscal_dis_capas(osv.Model):
    _inherit = 'fiscal.dis.capas'

    def fisdis_discp_btn_esboco(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'E'}, context=context)
        return True

    def fisdis_discp_btn_validar(self, cr, uid, ids, context=None):
        brw = self.browse(cr, uid, ids[0], context=context)
        if not brw.fisdis_discp_data_emissao:
            raise osv.except_osv(_('Atencao'), _('E necessario informar a data de emissao para validar!'))
        for brw_item in brw.fisdis_discp_item_ids:
            if not brw_item.fisdis_disit_pedido_id:
                raise osv.except_osv(_('Atencao'), _('Falta informar o pedido no item!'))
            if brw_item.fisdis_disit_pedido_id.id not in (brw.fisdis_discp_pedido1_id.id,
                                                          brw.fisdis_discp_pedido2_id.id,
                                                          brw.fisdis_discp_pedido3_id.id):
                raise osv.except_osv(_('Atencao'), _('Pedido informado no item nao consta na capa!'))
        self.write(cr, uid, ids, {'state': 'V'}, context=context)
        return True

    def fisdis_discp_btn_cancelar(self, cr, uid, ids, context=None):
        self.write(cr, uid, ids, {'state': 'C'}, context=context)
        return True

    def fisdis_discp_buscar_itens(self, cr, uid, ids, context=None):
        brw = self.browse(cr, uid, ids[0], context)
        lista_vals = []
        for brwPedidoItem in brw.fisdis_discp_pedido1_id.pedido_item_ids:
            vals = {
                'fisdis_disit_produto_id': brwPedidoItem.produto_id.id,
                'fisdis_disit_grade_id': brwPedidoItem.grade_id.id,
                'fisdis_disit_qtd': int(brwPedidoItem.qtde_pedida),
                'fisdis_disit_vr_total': brwPedidoItem.valor_total,
                'fisdis_disit_vr_itens': '1',
                'fisdis_disit_pedido_id': brw.fisdis_discp_pedido1_id.id,
            }
            lista_vals.append([0, 0, vals])
        if brw.fisdis_discp_pedido2_id:
            for brwPedidoItem in brw.fisdis_discp_pedido2_id.pedido_item_ids:
                vals = {
                    'fisdis_disit_produto_id': brwPedidoItem.produto_id.id,
                    'fisdis_disit_grade_id': brwPedidoItem.grade_id.id,
                    'fisdis_disit_qtd': int(brwPedidoItem.qtde_pedida),
                    'fisdis_disit_vr_total': brwPedidoItem.valor_total,
                    'fisdis_disit_vr_itens': '1',
                    'fisdis_disit_pedido_id': brw.fisdis_discp_pedido2_id.id,
                }
                lista_vals.append([0, 0, vals])
        if brw.fisdis_discp_pedido3_id:
            for brwPedidoItem in brw.fisdis_discp_pedido3_id.pedido_item_ids:
                vals = {
                    'fisdis_disit_produto_id': brwPedidoItem.produto_id.id,
                    'fisdis_disit_grade_id': brwPedidoItem.grade_id.id,
                    'fisdis_disit_qtd': int(brwPedidoItem.qtde_pedida),
                    'fisdis_disit_vr_total': brwPedidoItem.valor_total,
                    'fisdis_disit_vr_itens': '1',
                    'fisdis_disit_pedido_id': brw.fisdis_discp_pedido3_id.id,
                }
                lista_vals.append([0, 0, vals])

        self.write(cr, uid, ids[0], {'fisdis_discp_item_ids': lista_vals}, context=context)
        return True

    def __fiscal_dis_gravar_encargo(self, cr, uid, encargo_sigla, base, aliquota, imposto, nf_id, item_id, context=None):
        _dispositivo_fiscal = ''
        encargo_id = self.pool.get('fiscal.encargo').search(cr, uid, [('sigla', '=', encargo_sigla)], context=context,
                                                            limit=1)
        if not encargo_id:
            raise osv.except_osv(_('Atencao'), _('Encargo %s nao cadastrado!') % encargo_sigla)
        _tipo = 'T' if aliquota > 0 else 'O'
        tributacao_id = self.pool.get('fiscal.tributacao').search(cr, uid,
                                                                  [('encargo_id', '=', encargo_id[0]),
                                                                   ('aliquota', '=', aliquota),
                                                                   ('fistri_cst_tipo', '=', _tipo)],
                                                                  context=context, limit=1)
        if not tributacao_id:
            raise osv.except_osv(_('Atencao'), _('Tributacao nao cadastrado para o encargo %s com esta aliquota!!') % encargo_sigla)
        brw_tributacao = self.pool.get('fiscal.tributacao').browse(cr, uid, tributacao_id[0], context=context)
        if brw_tributacao.dispositivo_fiscal:
            _dispositivo_fiscal = '%s ' % brw_tributacao.dispositivo_fiscal
        _base = base
        _imp = 0
        _outros = 0
        _tributado = 0
        if brw_tributacao.cst_id.tipo == 'T' and aliquota > 0:
            _imp = imposto
            _tributado = _base
        else:
            _outros = _base
        vals = {
            'aliquota': aliquota,
            'cst_id': brw_tributacao.cst_id.id,
            'encargo_id': encargo_id[0],
            'fisnit_capa_id': nf_id,
            'fisnit_vr_outros': _outros,
            'fisnit_vr_tributado': _tributado,
            'movimento_itens_id': item_id,
            'tributacao_id': brw_tributacao.id,
            'vr_base_calculo': _base,
            'vr_encargo': _imp,
        }
        self.pool.get('fiscal.nf.item.tributacao').create(cr, uid, vals, context=context)
        return _dispositivo_fiscal

    def __fisdis_lancar_diferenca(self, cr, uid, numero_pedido, total_pedido, total_pedido_nf, data_atual, context=None):
        _par_fiscal = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'fiscal.parametro',
                                                          ['fispar_dis_perda_ganho_conta_id',
                                                           'fispar_dis_perda_evento_id', 'fispar_dis_ganho_evento_id'],
                                                          context=context)
        _diff = 0
        if total_pedido > total_pedido_nf:
            _diff = total_pedido - total_pedido_nf
            _perda_ganho = 'P'
        else:
            _diff = total_pedido_nf - total_pedido
            _perda_ganho = 'G'
        if _diff:
            _historico = '%s cambial no recebimento do pedido %s' % (
            'Perda' if _perda_ganho == 'P' else 'Ganho', numero_pedido)
            vals = {
                'conta_id': _par_fiscal.get('fispar_dis_perda_ganho_conta_id'),
                'data_movimento': data_atual[:10],
                'mes_competencia': data_atual[5:7],
                'ano_competencia': data_atual[:4],
                'valor': _diff,
                'historico': _historico,
                'debito_credito': 'D' if _perda_ganho == 'P' else 'C',
                'state': 'A',
                'fintem_documento': numero_pedido,
            }
            if _par_fiscal.get('fispar_dis_perda_evento_id') and _par_fiscal.get('fispar_dis_ganho_evento_id'):
                vals['gerencial_movimento_ids'] = [[0, False, {
                    'centro_custo_id': 1,
                    'evento_id': _par_fiscal.get(
                        'fispar_dis_perda_evento_id') if _perda_ganho == 'P' else _par_fiscal.get(
                        'fispar_dis_ganho_evento_id'),
                    'valor': _diff,
                    'fingmo_data': data_atual[:10],
                    'mes_competencia': data_atual[5:7],
                    'ano_competencia': data_atual[:4],
                    'fingmo_historico': _historico,
                    'fingmo_operacao': 'E' if _perda_ganho == 'G' else 'S',
                }]]
            self.pool.get('financeiro.tesouraria.movimento').create(cr, uid, vals, context=context)
        return True

    def fisdis_discp_gerar_nf(self, cr, uid, ids, context=None):
        brw = self.browse(cr, uid, ids[0], context=context)
        obj_adm_utils = self.pool.get('adm.utils')
        _par_fiscal = obj_adm_utils.admutl_get_parametros(cr, uid, 'fiscal.parametro',
                                                          ['id', 'fispar_dis_natureza_id', 'company_id',
                                                           'modelo_nf_series_id', 'fispar_dis_pedido_deb_conta_id',
                                                           'fispar_dis_pedido_cred_conta_id',
                                                           'fispar_dis_perda_ganho_conta_id'],
                                                          context=context)
        _company_id = _par_fiscal.get('company_id')
        _param_id = _par_fiscal.get('id')
        _modelo_ids = self.pool.get('fiscal.modelo.nf').search(cr, uid, [('fismnf_codigo', '=', '55')], context=context)
        if not _modelo_ids:
            raise osv.except_osv(_('Atencao'), _('Modelo de nf nao cadastrado: 55'))
        _modelo_id = _modelo_ids[0]
        _data_atual = datetime.utcnow().strftime('%Y-%m-%d %H:%M:%S')
        brw_natureza = self.pool.get('fiscal.cfop.natureza').browse(cr, uid,
                                                                    _par_fiscal.get('fispar_dis_natureza_id'), context)
        _endereco_id = brw.fisdis_discp_pedido1_id.pedcap_endereco_id.id
        if not _endereco_id:
            _endereco_id = brw.fisdis_discp_pedido1_id.pessoa_id.endereco_nf_id.id or brw.fisdis_discp_pedido1_id.pessoa_id.endereco_ids[0].id
        _nro_pedido = 'Pedido: %s' % brw.fisdis_discp_pedido1_id.numero_pedido
        if brw.fisdis_discp_pedido2_id:
            _nro_pedido += ', %s' % brw.fisdis_discp_pedido2_id.numero_pedido
        if brw.fisdis_discp_pedido3_id:
            _nro_pedido += ', %s' % brw.fisdis_discp_pedido3_id.numero_pedido
        vals_nf = {
            'tipo': 'E',
            'fisnfc_tipo_servico': False,
            'nf_propria': True,
            'natureza_id': _par_fiscal.get('fispar_dis_natureza_id'),
            'modelo_nf_series_id': _par_fiscal.get('modelo_nf_series_id'),
            'modelo_nf_id': _modelo_id,
            'destinatario_id': brw.fisdis_discp_pedido1_id.pessoa_id.id,
            'destinatario_endereco_id': _endereco_id,
            'data_emissao': _data_atual,
            'hora_emissao': _data_atual,
            'data_saida_entrada': _data_atual,
            'modelo_55': True,
            'fisnfc_consumidor': False,
            'gerar_xml': True,
            'nfe_forma_impressao_danfe': '1',
            'nfe_processo_emissao': '0',
            'fisnfc_nfe_indicador_presenca': '2',
            # 'nfe_versao_processo_emissao': dados.get('xml_version'),
            'nfe_forma_emissao': '1',
            'finalidade_emissao': '1',
            'vr_desconto': 0.0,
            'vr_icms_substituicao': 0.0,
            'vr_base_icms_substituicao': 0.0,
            'vr_seguro': 0.0,
            'vr_despesas_acessorias': brw.fisdis_discp_vr_multa,
            'vr_frete': brw.fisdis_discp_vr_frete,
            'frete': '0' if brw.fisdis_discp_vr_frete else '9',
            'fisnfc_infcomp_contribuinte': _nro_pedido,
            'fisnfc_infcomp_fisco': '',
            'tipo_frete': 'D',
        }
        nf_id = self.pool.get('fiscal.nf.capa').create(cr, uid, vals_nf, context=context)
        brw_nf = self.pool.get('fiscal.nf.capa').browse(cr, uid, nf_id, context=context)
        mov_capa_id = brw_nf.estoque_movimento_capa_ids[0].id
        _user_dados = self.pool.get('res.users').read(cr, uid, uid, ['pessoa_id'], context=context)
        if not _user_dados:
            raise osv.except_osv(_('Atencao'), _('O Usuario %s nao tem uma pessoa_id!') % uid)

        vals = {
            'fisdim_data' : _data_atual[:10],
            'fisdim_data_desembaraco': brw.fisdis_discp_data_emissao,
            'fisdim_exportador': brw.fisdis_discp_pedido1_id.pessoa_id.codigo,
            'fisdim_forma_importacao': '1',
            'fisdim_local_desembaraco': brw.fisdis_discp_local_id.name,
            'fisdim_nf_id': nf_id,
            'fisdim_numero': brw.fisdis_discp_numero,
            'fisdim_uf_id': brw.fisdis_discp_local_id.fisdis_lcds_uf_id.id,
            'fisdim_via_transporte': '5',
            'fisdim_vr_afrmm': 0.0,
            'fisdim_vr_despesa': 0.0,
            'fisdim_adicao_ids': [(0,0,{
                'fisdia_fabricante': brw.fisdis_discp_pedido1_id.pessoa_id.codigo,
                'fisdia_numero': (self.pool.get('fiscal.declaracao.importacao.adicao').search(cr, uid, [], count=True) or 0) + 1,
                'sequence': 1,
            })]
        }
        self.pool.get('fiscal.declaracao.importacao').create(cr, uid, vals, context=context)

        acrescimos = brw.fisdis_discp_vr_frete + brw.fisdis_discp_vr_multa
        vr_bem_total = 0.0 + acrescimos
        lista = []
        for brw_item in brw.fisdis_discp_item_ids:
            lista.append([brw_item.id, brw_item.fisdis_disit_vr_itens])
            vr_bem_total += brw_item.fisdis_disit_vr_itens

        _lista = copy.deepcopy(lista)
        base_dict = dict(self.pool.get('adm.utils').efetuar_rateio(vr_bem_total, _lista))
        _lista = copy.deepcopy(lista)
        frete_dict = dict(self.pool.get('adm.utils').efetuar_rateio(brw.fisdis_discp_vr_frete, _lista))
        _lista = copy.deepcopy(lista)
        multa_dict = dict(self.pool.get('adm.utils').efetuar_rateio(brw.fisdis_discp_vr_multa, _lista))
        _lista = copy.deepcopy(lista)
        ii_base_dict = dict(self.pool.get('adm.utils').efetuar_rateio(brw.fisdis_discp_ii_base, _lista))
        _lista = copy.deepcopy(lista)
        ii_vr_dict = dict(self.pool.get('adm.utils').efetuar_rateio(brw.fisdis_discp_ii_vr, _lista))
        _lista = copy.deepcopy(lista)
        icms_base_dict = dict(self.pool.get('adm.utils').efetuar_rateio(brw.fisdis_discp_icms_base, _lista))
        _lista = copy.deepcopy(lista)
        icms_vr_dict = dict(self.pool.get('adm.utils').efetuar_rateio(brw.fisdis_discp_icms_vr, _lista))
        dispositivo_fiscal = ''
        sequencia = 0
        total_nf_pedido1 = total_nf_pedido2 = total_nf_pedido3 = 0.0
        for brw_item in brw.fisdis_discp_item_ids:
            args = [
                ('grade_id', '=', brw_item.fisdis_disit_grade_id.id),
                ('local_id', '=', brw.fisdis_discp_local_entrada_id.id)
            ]
            locacao_id = self.pool.get('estoque.local.locacao').search(cr, uid, args, context=context, limit=1)
            if not locacao_id:
                raise osv.except_osv(_('Atencao'), _('Locacao nao cadastrada para o produto'))
            dados_prod_emb = self.pool.get('estoque.local.locacao').read(cr, uid, locacao_id, ['estllc_produto_embalagem_id'], context=context)
            prod_emb_id = dados_prod_emb[0].get('estllc_produto_embalagem_id')[0]
            sequencia += 1
            vals = {
                'local_id': brw.fisdis_discp_local_entrada_id.id,
                'nf_id': nf_id,
                'sequencia': sequencia,
                'cfop_id': brw_natureza.cfop_id.id,
                'capa_id': mov_capa_id,
                'natureza_id': brw_natureza.id,
                'produto_id': brw_item.fisdis_disit_produto_id.id,
                'quantidade': brw_item.fisdis_disit_qtd,
                'produto_embalagem_id': prod_emb_id,
                'grade_id': brw_item.fisdis_disit_grade_id.id,
                'vr_desconto': 0.0,
                'vr_desconto_rateado': 0.0,
                'vr_despesas_rateado': multa_dict.get(brw_item.id),
                'estmvi_vr_despesas_extras_rateado': 0.0,
                'vr_preco_venda': brw_item.fisdis_disit_vr_itens,
                'vr_unitario': brw_item.fisdis_disit_vr_itens / brw_item.fisdis_disit_qtd,
                'vr_total_item': brw_item.fisdis_disit_vr_itens,
                'vr_frete_rateado': frete_dict.get(brw_item.id),
                'vr_total_item_rateado': brw_item.fisdis_disit_vr_itens +
                                         frete_dict.get(brw_item.id) +
                                         multa_dict.get(brw_item.id) +
                                         ii_vr_dict.get(brw_item.id) +
                                         icms_vr_dict.get(brw_item.id)
            }
            item_id = self.pool.get('estoque.movimento.itens').create(cr, uid, vals, context=context)
            self.pool.get('fiscal.dis.itens').write(cr, uid, brw_item.id,
                                                    {'fisdis_disit_custo_final': vals.get('vr_total_item_rateado')},
                                                    context=context)
            if brw_item.fisdis_disit_pedido_id.id == brw.fisdis_discp_pedido1_id.id:
                total_nf_pedido1 += vals.get('vr_total_item_rateado')
            elif brw_item.fisdis_disit_pedido_id.id == brw.fisdis_discp_pedido2_id.id:
                total_nf_pedido2 += vals.get('vr_total_item_rateado')
            elif brw_item.fisdis_disit_pedido_id.id == brw.fisdis_discp_pedido3_id.id:
                total_nf_pedido3 += vals.get('vr_total_item_rateado')
            dispositivo_fiscal += self.__fiscal_dis_gravar_encargo(cr, uid,
                                             encargo_sigla='II',
                                             base=ii_base_dict.get(brw_item.id),
                                             aliquota=brw.fisdis_discp_ii_aliq,
                                             imposto=ii_vr_dict.get(brw_item.id),
                                             nf_id=nf_id,
                                             item_id=item_id,
                                             context=context)
            dispositivo_fiscal += self.__fiscal_dis_gravar_encargo(cr, uid,
                                             encargo_sigla='ICMS',
                                             base=icms_base_dict.get(brw_item.id),
                                             aliquota=brw.fisdis_discp_icms_aliq,
                                             imposto=icms_vr_dict.get(brw_item.id),
                                             nf_id=nf_id,
                                             item_id=item_id,
                                             context=context)
            dispositivo_fiscal += self.__fiscal_dis_gravar_encargo(cr, uid,
                                             encargo_sigla='IPI',
                                             base=icms_base_dict.get(brw_item.id),
                                             aliquota=0,
                                             imposto=0,
                                             nf_id=nf_id,
                                             item_id=item_id,
                                             context=context)
            dispositivo_fiscal += self.__fiscal_dis_gravar_encargo(cr, uid,
                                             encargo_sigla='PIS',
                                             base=icms_base_dict.get(brw_item.id),
                                             aliquota=0,
                                             imposto=0,
                                             nf_id=nf_id,
                                             item_id=item_id,
                                             context=context)
            dispositivo_fiscal += self.__fiscal_dis_gravar_encargo(cr, uid,
                                             encargo_sigla='COFINS',
                                             base=icms_base_dict.get(brw_item.id),
                                             aliquota=0,
                                             imposto=0,
                                             nf_id=nf_id,
                                             item_id=item_id,
                                             context=context)
            self.pool.get('estoque.movimento.itens').write(cr, uid, item_id, {}, context=context)
        self.pool.get('estoque.movimento.capa').write(cr, uid, mov_capa_id, {}, context=context)
        self.pool.get('fiscal.nf.capa').write(cr, uid, nf_id, {}, context=context)
        brw_nf = self.pool.get('fiscal.nf.capa').browse(cr, uid, nf_id, context=context)
        _forma_pagto_id = self.pool.get('adm.forma.pgto').search(cr, uid, [('sigla', '=', 'DN')], context=context, limit=1)
        if not _forma_pagto_id:
            raise osv.except_osv(_('Atencao'), _('Forma de pagamento "Dinheiro" nao encontrada!'))
        _condicao_forma_id = self.pool.get('adm.condicao.forma').search(cr, uid, [('forma_pagamento_id', '=', _forma_pagto_id[0])], context=context, limit=1)
        if not _condicao_forma_id:
            raise osv.except_osv(_('Atencao'), _('Condicao de pagamento "Dinheiro" nao encontrada!'))
        vals = {
            'capa_id': nf_id,
            'condicao_forma_id': _condicao_forma_id[0],
            'forma_pagto_id': _forma_pagto_id[0],
            'valor': brw_nf.vr_total_nf,
            'nf_parcela_ids': [(0,0, {
                'active': True,
                'prazo': 0,
                'prazo_tipo': 'DD',
                'valor': brw_nf.vr_total_nf,
                'vencimento': _data_atual[:10]
            })]
        }
        self.pool.get('fiscal.condicao.pagamento').create(cr, uid, vals, context=context)
        vals = {
            'fisdis_discp_nf_id': nf_id,
            'state': 'G',
            'fisdis_discp_vr_nf': brw_nf.vr_total_nf
        }
        self.write(cr, uid, ids, vals, context=context)
        vals_ped = {
            'state': 'F',
            'pedcap_nf_ids': [(6, 0, [nf_id])],
            'pedcap_data_faturamento': _data_atual[:10]
        }
        self.pool.get('estoquepedidos.pedido.capa').write(cr, uid, brw.fisdis_discp_pedido1_id.id, vals_ped, context=context)
        if brw.fisdis_discp_pedido2_id:
            self.pool.get('estoquepedidos.pedido.capa').write(cr, uid, brw.fisdis_discp_pedido2_id.id, vals_ped, context=context)
        if brw.fisdis_discp_pedido3_id:
            self.pool.get('estoquepedidos.pedido.capa').write(cr, uid, brw.fisdis_discp_pedido3_id.id, vals_ped, context=context)
        if _par_fiscal.get('fispar_dis_pedido_deb_conta_id') and _par_fiscal.get('fispar_dis_pedido_cred_conta_id'):
            vals = {
                'conta_id': _par_fiscal.get('fispar_dis_pedido_deb_conta_id'),
                'conta_destino_id': _par_fiscal.get('fispar_dis_pedido_cred_conta_id'),
                'data_movimento': _data_atual[:10],
                'mes_competencia': _data_atual[5:7],
                'ano_competencia': _data_atual[:4],
                'valor': brw.fisdis_discp_pedido1_id.valor_total,
                'historico': 'Recebimento do pedido %s' % brw.fisdis_discp_pedido1_id.numero_pedido,
                'debito_credito': 'D',
                'state': 'A',
                'fintem_documento': brw.fisdis_discp_pedido1_id.numero_pedido
            }
            self.pool.get('financeiro.tesouraria.movimento').create(cr, uid, vals, context=context)
            if brw.fisdis_discp_pedido2_id:
                vals['valor'] = brw.fisdis_discp_pedido2_id.valor_total
                vals['historico'] = 'Recebimento do pedido %s' % brw.fisdis_discp_pedido2_id.numero_pedido
                vals['fintem_documento'] = brw.fisdis_discp_pedido2_id.numero_pedido
                self.pool.get('financeiro.tesouraria.movimento').create(cr, uid, vals, context=context)
            if brw.fisdis_discp_pedido3_id:
                vals['valor'] = brw.fisdis_discp_pedido3_id.valor_total
                vals['historico'] = 'Recebimento do pedido %s' % brw.fisdis_discp_pedido3_id.numero_pedido
                vals['fintem_documento'] = brw.fisdis_discp_pedido3_id.numero_pedido
                self.pool.get('financeiro.tesouraria.movimento').create(cr, uid, vals, context=context)
        if _par_fiscal.get('fispar_dis_perda_ganho_conta_id'):
            if total_nf_pedido1 != brw.fisdis_discp_pedido1_id.valor_total:
                self.__fisdis_lancar_diferenca(cr, uid,
                                               brw.fisdis_discp_pedido1_id.numero_pedido,
                                               brw.fisdis_discp_pedido1_id.valor_total,
                                               total_nf_pedido1,
                                               _data_atual,
                                               context=context)
            if total_nf_pedido2:
                if total_nf_pedido2 != brw.fisdis_discp_pedido2_id.valor_total:
                    self.__fisdis_lancar_diferenca(cr, uid,
                                                   brw.fisdis_discp_pedido2_id.numero_pedido,
                                                   brw.fisdis_discp_pedido2_id.valor_total,
                                                   total_nf_pedido2,
                                                   _data_atual,
                                                   context=context)
            if total_nf_pedido3:
                if total_nf_pedido3 != brw.fisdis_discp_pedido3_id.valor_total:
                    self.__fisdis_lancar_diferenca(cr, uid,
                                                   brw.fisdis_discp_pedido3_id.numero_pedido,
                                                   brw.fisdis_discp_pedido3_id.valor_total,
                                                   total_nf_pedido3,
                                                   _data_atual,
                                                   context=context)
        return True


    def fisdis_discp_btn_atualizar(self, cr, uid, ids, context=None):
        return True

    def fisdis_discp_onchange_ii_aliq(self, cr, uid, ids, ii_base, ii_aliq, context=None):
        if ii_base == 0 or ii_aliq == 0:
            return {'value': {'fisdis_discp_ii_vr': 0}}
        ii_valor = ii_base * ii_aliq / 100
        res = {'value': {'fisdis_discp_ii_vr': ii_valor}}
        encargo_id = self.pool.get('fiscal.encargo').search(cr, uid, [('sigla', '=', 'II')], context=context, limit=1)
        if not encargo_id:
            res['warning'] = {'title': 'Atencao:'}
            res['warning']['message'] = 'Nao existe o encargo II cadastrado!'
            return res
        tributacao_id = self.pool.get('fiscal.tributacao').search(cr , uid,
                                                                  [('encargo_id', '=', encargo_id[0]),
                                                                   ('aliquota', '=', ii_aliq)],
                                                                  context=context, limit=1)
        if not tributacao_id:
            res['warning'] = {'title': 'Atencao:'}
            res['warning']['message'] = 'Nao existe o tributacao cadastrada para o encargo II com esta aliquota!'
        return res

    def fisdis_discp_onchange_icms_aliq(self, cr, uid, ids, icms_base, icms_aliq, context=None):
        if icms_base == 0 or icms_aliq == 0:
            return {'value': {'fisdis_discp_icms_vr': 0}}
        icms_valor = icms_base * icms_aliq / 100
        res = {'value': {'fisdis_discp_icms_vr': icms_valor}}
        encargo_id = self.pool.get('fiscal.encargo').search(cr, uid, [('sigla', '=', 'ICMS')], context=context, limit=1)
        if not encargo_id:
            res['warning'] = {'title': 'Atencao:'}
            res['warning']['message'] = 'Nao existe o encargo ICMS cadastrado!'
            return res
        tributacao_id = self.pool.get('fiscal.tributacao').search(cr, uid,
                                                                  [('encargo_id', '=', encargo_id[0]),
                                                                   ('aliquota', '=', icms_aliq)],
                                                                  context=context, limit=1)
        if not tributacao_id:
            res['warning'] = {'title': 'Atencao:'}
            res['warning']['message'] = 'Nao existe o tributacao cadastrada para o encargo ICMS com esta aliquota!'
        return res

