# -*- coding: utf-8 -*-

from openerp.osv import osv


class gerencial_movimento(osv.Model):
    _inherit = 'gerencial.movimento'

    def agrupar_gerencial_centro_custo(self, cr, uid, centro_custo_evento, documento, context=None):
        if documento.get('tipo_nf') != 'E':
            res = super(gerencial_movimento, self).agrupar_gerencial_centro_custo(cr, uid, centro_custo_evento, documento, context=context)
            return res
        _par_fiscal = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'fiscal.parametro',
                                                          ['fispar_dis_impostos_evento_id'],
                                                          context=context)
        impostos_evento_id = _par_fiscal.get('fispar_dis_impostos_evento_id')
        if not impostos_evento_id:
            res = super(gerencial_movimento, self).agrupar_gerencial_centro_custo(cr, uid, centro_custo_evento,
                                                                                  documento, context=context)
            return res
        brw_nf = self.pool.get('fiscal.nf.capa').browse(cr, uid, documento.get('id'), context=context)
        if brw_nf.natureza_id.cfop_id.codigo[0] != '3':  # Somente nota de importacao
            res = super(gerencial_movimento, self).agrupar_gerencial_centro_custo(cr, uid, centro_custo_evento,
                                                                                  documento, context=context)
            return res
        _imposto = 0.0
        for brw_imposto in brw_nf.tributacao_agrupar_ids:
            if brw_imposto.tipo == 'T':
                _imposto += brw_imposto.vr_encargo
        i = 0
        total_inserido = 0.0
        for x in centro_custo_evento:
            i += 1
            if i < 2:
                continue
            total_inserido += x.get('valor')
        total_inserido += _imposto
        centro_custo_evento[0]['valor'] = centro_custo_evento[0].get('valor') - total_inserido
        if _imposto:
            centro_custo_evento.append({
                'pessoa_id': centro_custo_evento[0].get('pessoa_id'),
                'fingmo_historico': '%s - %s' % (centro_custo_evento[0].get('fingmo_historico'), 'Impostos de Importacao'),
                'ano_competencia': centro_custo_evento[0].get('ano_competencia'),
                'centro_custo_id': centro_custo_evento[0].get('centro_custo_id'),
                'fingmo_data': centro_custo_evento[0].get('fingmo_data'),
                'company_id': centro_custo_evento[0].get('company_id'),
                'fingmo_operacao': centro_custo_evento[0].get('fingmo_operacao'),
                'fingmo_nf_id': centro_custo_evento[0].get('fingmo_nf_id'),
                'mes_competencia': centro_custo_evento[0].get('mes_competencia'),
                'valor': _imposto,
                'evento_id': impostos_evento_id,
            })

        res = super(gerencial_movimento, self).agrupar_gerencial_centro_custo(cr, uid, centro_custo_evento, documento, context=context)
        return res
