# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class fiscal_parametro(osv.Model):
    _inherit = 'fiscal.parametro'
    _columns = {
        'fispar_dis_natureza_id': fields.many2one('fiscal.cfop.natureza',
                                                  'Natureza para nota de DIS',
                                                  ondelete="restrict",
                                                  select=True),
        'fispar_dis_impostos_evento_id': fields.many2one('gerencial.evento',
                                                         'Evento p/impostos importacao',
                                                         ondelete='restrict',
                                                         select=True,
                                                  help="Evento para classificacao da custificacao dos impostos. "
                                                       "Nao havendo evento, nao classificar apenas o imposto."),
        'fispar_dis_pedido_deb_conta_id': fields.many2one('financeiro.tesouraria.contas',
                                                           'Conta Debito Pedido',
                                                           help='Conta do pedido no financeiro(Se houver)',
                                                           ondelete='restrict',
                                                           select=True),
        'fispar_dis_pedido_cred_conta_id': fields.many2one('financeiro.tesouraria.contas',
                                                           'Conta Credito Pedido',
                                                           help='Conta do pedido no financeiro(Se houver)',
                                                           ondelete='restrict',
                                                           select=True),
        'fispar_dis_perda_ganho_conta_id': fields.many2one('financeiro.tesouraria.contas',
                                                           'Conta perda/ganho',
                                                           help='Conta para lancar a perda ou ganho no financeiro',
                                                           ondelete='restrict',
                                                           select=True),
        'fispar_dis_perda_evento_id': fields.many2one('gerencial.evento', 'Evento p/perda cambial',
                                                  help="Evento para classificacao da perda cambial. "
                                                       "Quando o valor do pedido e maior do que o da nota",
                                                           ondelete='restrict',
                                                           select=True),
        'fispar_dis_ganho_evento_id': fields.many2one('gerencial.evento', 'Evento p/ganho cambial',
                                                     help="Evento para classificacao do ganho cambial. "
                                                          "Quando o valor do pedido e menor do que o da nota",
                                                           ondelete='restrict',
                                                           select=True),

    }


