# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class fiscal_dis_capas(osv.Model):
    """
    Tabela de Capa da DIS
    prefixo: fisdis_discp_
    """
    _name = 'fiscal.dis.capas'
    _rec_name = 'fisdis_discp_numero'
    _columns = {
        'id': fields.integer('id'),
        'fisdis_discp_local_id': fields.many2one('fiscal.dis.locais.desembaraco', 'Local desembaraco',
                                               required=True, select=1),
        'fisdis_discp_numero': fields.char('Numero', size=13, required=True, select=1),
        'fisdis_discp_pedido1_id': fields.many2one('estoquepedidos.pedido.capa', 'Pedido 1', required=True,
                                             select=True, domain="[('tipo','=','C'), ('state', '=', 'V')]",
                                             oldname='fisdis_discp_pedido_id'),
        'fisdis_discp_pedido2_id': fields.many2one('estoquepedidos.pedido.capa', 'Pedido 2',
                                             select=True, domain="[('tipo','=','C'), ('state', '=', 'V')]",
                                             oldname='fisdis_discp_pedido'),
        'fisdis_discp_pedido3_id': fields.many2one('estoquepedidos.pedido.capa', 'Pedido 3',
                                             select=True, domain="[('tipo','=','C'), ('state', '=', 'V')]",
                                             oldname='fisdis_discp_pedido'),
        'fisdis_discp_nf_id': fields.many2one('fiscal.nf.capa', 'NFe', select=True),
        'fisdis_discp_vr_nf': fields.float('Valor da NFe', digits=(9, 2)),
        'fisdis_discp_vr_frete': fields.float('Valor do Frete', digits=(9, 2)),
        'fisdis_discp_ii_base': fields.float('Valor Aduaneiro', digits=(9, 2), required=True),
        'fisdis_discp_ii_aliq': fields.float('Aliquota Imposto Importacao', digits=(3,2)),
        'fisdis_discp_ii_vr': fields.float('Valor do II Devido', digits=(9, 2)),
        'fisdis_discp_vr_multa': fields.float('Multas', digits=(9, 2)),
        'fisdis_discp_icms_base': fields.float('Base Calculo ICMS', digits=(9, 2)),
        'fisdis_discp_icms_aliq': fields.float('Aliquota ICMS', digits=(3,2)),
        'fisdis_discp_icms_vr': fields.float('Valor do IICMS Devido', digits=(9, 2)),
        'fisdis_discp_data_emissao': fields.date('Data de emissao'),
        'fisdis_discp_local_entrada_id': fields.many2one('estoque.local', 'Local entrada', required=True, select=True),
        'fisdis_discp_item_ids': fields.one2many('fiscal.dis.itens', 'fisdis_disit_capa_id', 'Itens'),
        'state': fields.selection([('E', 'Esboco'), ('V', 'Validado'), ('G', 'Gerado'), ('C', 'Cancelado')], 'Situacao', select=True),
    }
    _defaults = {
        'state': 'E',
    }
    _order = 'id desc'
