# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class fiscal_dis_items(osv.Model):
    """
    Tabela de itens da DIS
    prefixo: fisdis_disit_
    """
    _name = 'fiscal.dis.itens'
    _rec_name = 'fisdis_disit_capa_id'
    _columns = {
        'fisdis_disit_capa_id': fields.many2one('fiscal.dis.capas', 'Capa', required=True, select=1),
        'fisdis_disit_produto_id': fields.many2one('estoque.produto', 'Produto', required=True, select=1),
        'fisdis_disit_grade_id': fields.many2one('estoque.produto.grade', 'Grade', required=True, select=True,
                                                 domain="[('produto_id','=',fisdis_disit_produto_id)]"),
        'fisdis_disit_qtd': fields.integer('Quantidade', required=True),
        'fisdis_disit_vr_itens': fields.float('Valor do Bem', digits=(9,2), required=True),
        'fisdis_disit_vr_total': fields.float('Valor total pedido', digits=(9,2), required=True),
        'fisdis_disit_custo_final': fields.float('Custo total', digits=(9,2), required=True),
        'fisdis_disit_pedido_id': fields.many2one('estoquepedidos.pedido.capa', 'Pedido',
                                                   select=True, domain="[('tipo','=','C'), ('state', '=', 'V')]"),
    }
