# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from datetime import datetime, timedelta
from ordereddict import OrderedDict
import logging

# Tipo de grafico 1: 1 hora, 2: 6 horas, 3: 12 horas, 4: 24 horas
dict_tipo = {'2': 6, '3': 12, '4': 24}


class gesbas_servidores_grafico(osv.Model):
    _inherit = 'gesbas.servidores.graficos'
    _logger = logging.getLogger(_inherit)

    def gesbas_segr_gerar_estatisticas_tipo1(self, cr, uid, context=None):
        _dataAgora = datetime.now()
        _dataAgoraStr = _dataAgora.strftime('%Y-%m-%d %H:%M:00')
        self.pool.get('ir.config_parameter').set_param(cr, uid, 'gesbas_servidor_uso', _dataAgoraStr)
        i = 0
        dict_1_hora = OrderedDict()
        listaHorarios1 = []
        while True:
            i += 1
            _dataHora = _dataAgora - timedelta(minutes=i)
            _dataHoraStr = _dataHora.strftime('%Y-%m-%d %H:%M')
            listaHorarios1.append(_dataHoraStr)
            if i > 59:
                break
        args = [('gesbas_serv_data_hora', '<', _dataAgoraStr)]
        dados_serv = self.pool.get('gesbas.servidores').read_group(cr, uid, args, ['name'], groupby='name')
        _lista_serv = [x.get('name') for x in dados_serv]
        _limit = len(_lista_serv) * 65
        gesbas_servidores_ids = self.pool.get('gesbas.servidores').search(cr, uid, args,
                                                                          order='gesbas_serv_data_hora desc,name',
                                                                          limit=_limit)
        _fields = ['name', 'gesbas_serv_data_hora', 'gesbas_serv_cpu_1_min', 'gesbas_serv_avg_1_min']
        dados = self.pool.get('gesbas.servidores').read(cr, uid, gesbas_servidores_ids, _fields)
        for linha in dados:
            _dataHoraStr = linha.get('gesbas_serv_data_hora')[:-3]
            _servidor = linha.get('name')
            if not dict_1_hora.get(_servidor):
                dict_1_hora[_servidor] = OrderedDict()
                for x in listaHorarios1:
                    dict_1_hora[_servidor][x] = {'cpu': 0, 'avg': 0}
            if dict_1_hora.get(_servidor).get(_dataHoraStr):
                dict_1_hora[_servidor][_dataHoraStr]['cpu'] = linha.get('gesbas_serv_cpu_1_min')
                dict_1_hora[_servidor][_dataHoraStr]['avg'] = linha.get('gesbas_serv_avg_1_min')
        args = [('gesbas_segr_tipo', '=', '1')]
        _servGra_ids = self.pool.get('gesbas.servidores.graficos').search(cr, uid, args)
        self.pool.get('gesbas.servidores.graficos').unlink(cr, uid, _servGra_ids)
        for servidorKey in dict_1_hora.keys():
            for horarioKey in dict_1_hora.get(servidorKey).keys():
                _data = datetime.strptime(horarioKey + ':00', '%Y-%m-%d %H:%M:%S')
                _data_com_tz = self.pool.get('adm.utils').admutl_converte_tz(cr, uid, _data, tz_origem='UTC')
                _horario = _data_com_tz.strftime('%H:%M')
                values = {
                    'name': servidorKey,
                    'gesbas_segr_tipo': '1',
                    'gesbas_segr_data_hora': _horario,
                    'gesbas_segr_cpu': dict_1_hora.get(servidorKey).get(horarioKey).get('cpu'),
                    'gesbas_segr_avg': dict_1_hora.get(servidorKey).get(horarioKey).get('avg'),
                }
                self.pool.get('gesbas.servidores.graficos').create(cr, uid, values)
        return True

    def gesbas_segr_gerar_estatisticas_tipo(self, cr, uid, tipo, context=None):
        _dataAgora = datetime.now()
        _dataAgoraStr = _dataAgora.strftime('%Y-%m-%d %H:%M:00')
        i = 0
        listaHorarios = []
        while True:
            i += 1
            _dataHora = _dataAgora - timedelta(minutes=(i * dict_tipo.get(tipo)))
            _dataHoraStr = _dataHora.strftime('%Y-%m-%d %H:%M')
            listaHorarios.append(_dataHoraStr)
            if i > 59:
                break
        args = [('gesbas_segr_tipo', '=', tipo)]
        _servGra_ids = self.pool.get('gesbas.servidores.graficos').search(cr, uid, args)
        self.pool.get('gesbas.servidores.graficos').unlink(cr, uid, _servGra_ids)
        args = [('gesbas_serv_data_hora', '<', _dataAgoraStr)]
        dados_serv = self.pool.get('gesbas.servidores').read_group(cr, uid, args, ['name'], groupby='name')
        _lista_serv = [x.get('name') for x in dados_serv]
        _horarioAnterior = False
        for _horario in listaHorarios:
            if not _horarioAnterior:
                _horarioAnterior = _horario
                continue
            _sql_cpu = """
                select name, avg(gesbas_serv_cpu_1_min) as cpu, avg(gesbas_serv_avg_1_min) as avg
                    from gesbas_servidores
                    where gesbas_serv_data_hora <= '%s' and gesbas_serv_data_hora > '%s' and 
                          gesbas_serv_cpu_1_min > 0 and gesbas_serv_avg_1_min > 0
                    group by name    
            """ % (_horarioAnterior, _horario)
            cr.execute(_sql_cpu)
            for _dados  in [dict(zip([col[0] for col in cr.description], row)) for row in cr.fetchall()]:
                _data = datetime.strptime(_horarioAnterior + ':00', '%Y-%m-%d %H:%M:%S')
                _data_com_tz = self.pool.get('adm.utils').admutl_converte_tz(cr, uid, _data, tz_origem='UTC')
                _horarioVisual = _data_com_tz.strftime('%H:%M')
                values = {
                    'name': _dados.get('name'),
                    'gesbas_segr_tipo': tipo,
                    'gesbas_segr_data_hora': _horarioVisual,
                    'gesbas_segr_cpu': _dados.get('cpu'),
                    'gesbas_segr_avg': _dados.get('avg'),
                }
                self.pool.get('gesbas.servidores.graficos').create(cr, uid, values)
            _horarioAnterior = _horario
        return True

    def gesbas_segr_gerar_estatisticas(self, cr, uid, context=None):
        self._logger.info('=======> Gerando estatisticas de uso do servidor - Inicio')
        _dataAgora = datetime.now()
        _dataAgoraMenos5Min = _dataAgora - timedelta(minutes=5)
        _ultimoAcessoStr = self.pool.get('ir.config_parameter').get_param(cr, uid, 'gesbas_servidor_uso', False)
        if not _ultimoAcessoStr:
            _ultimoAcessoStr = _dataAgora.strftime('%Y-%m-%d %H:%M:00')
        _ultimoAcesso = datetime.strptime(_ultimoAcessoStr, '%Y-%m-%d %H:%M:00')
        if _ultimoAcesso < _dataAgoraMenos5Min:
            return True
        self.gesbas_segr_gerar_estatisticas_tipo1(cr, uid, context=context)

        for tipo in dict_tipo.keys():
            self.gesbas_segr_gerar_estatisticas_tipo(cr, uid, tipo, context=None)

        self._logger.info('=======> Gerando estatisticas de uso do servidor - Fim')
        return True

    def gesbas_segr_cron_gerar_estatisticas(self, cr, uid, prazo=None):
        _dataAgora = datetime.now()
        _dataAgoraStr = _dataAgora.strftime('%Y-%m-%d %H:%M:00')
        self.pool.get('ir.config_parameter').set_param(cr, uid, 'gesbas_servidor_uso', _dataAgoraStr)
        return self.gesbas_segr_gerar_estatisticas(cr, uid)

    def search(self, cr, user, args, offset=0, limit=None, order=None, context=None, count=False):
        if context and context.get('grafico'):
            order = 'name, id desc'
        res = super(gesbas_servidores_grafico, self).search(cr, user, args, offset=offset, limit=limit, order=order,
                                                            context=context, count=count)
        return res