# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from datetime import date, datetime

# def _gesbas_get_data(self, cr, uid, ids, name, arg, context=None):
#     res = {}
#     obj = self.browse(cr, uid, ids)
#     for x in obj:
#         _data = datetime.strptime(x.gesbas_segr_data_hora+':00', '%Y-%m-%d %H:%M:%S')
#         _data_com_tz = self.pool.get('adm.utils').admutl_converte_tz(cr, uid, _data, tz_origem='UTC')
#         if x.gesbas_segr_tipo in ('1', '2', '3', '4'):
#             res[x.id] = _data_com_tz.strftime('%H:%M')
#         elif x.gesbas_segr_tipo == '5':
#             res[x.id] = _data_com_tz.strftime('%d %H hs')
#         else:
#             res[x.id] = _data_com_tz.strftime('%d-%m')
#     return res

def _gesbas_bccl_nome_cliente(self, cursor, user, ids, name, arg, context=None):
    """
    Retorna o nome do cliente
    """
    context = context and context.copy() or {}
    res = {}
    for cliente in self.browse(cursor, user, ids, context=context):
        if cliente.gesbas_clie_pessoa_id:
            res[cliente.id] = cliente.gesbas_clie_pessoa_id.name
        else:
            res[cliente.id] = False
    return res

def _gesbas_back_nome_cliente(self, cursor, user, ids, name, arg, context=None):
    """
    Retorna o nome do cliente
    """
    context = context and context.copy() or {}
    res = {}
    for cliente in self.browse(cursor, user, ids, context=context):
        if cliente.gesbas_back_pessoa_id:
            res[cliente.id] = cliente.gesbas_back_pessoa_id.name
        else:
            res[cliente.id] = False
    return res

def _gesbas_aces_get_nao_stored(self, cursor, user, ids, name, arg, context=None):
    """
    Retorna os dados nao storeados
    """
    context = context and context.copy() or {}
    res = {}
    for cliente in self.browse(cursor, user, ids, context=context):
        if cliente.gesbas_aces_pessoa_id:
            vals = {
                'name': cliente.gesbas_aces_pessoa_id.name,
            }
            res[cliente.id] = vals
    return res

def _gesbas_aces_get_stored(self, cursor, user, ids, name, arg, context=None):
    """
    Retorna os dados que sao storeadps
    """
    context = context and context.copy() or {}
    res = {}
    for acessos in self.browse(cursor, user, ids, context=context):
        if acessos.gesbas_aces_pessoa_id:
            gesbase_clie_ids = self.pool.get('gesbas.cliente').search(cursor, user,
                                                                      [('gesbas_clie_pessoa_id', '=', acessos.gesbas_aces_pessoa_id.id)],
                                                                      limit=1)
            gesbase_clie_brw = self.pool.get('gesbas.cliente').browse(cursor, user, gesbase_clie_ids[0])
            vals = {
                'gesbas_aces_servidor': gesbase_clie_brw.gesbas_clie_servidor,
                'gesbas_aces_porta': gesbase_clie_brw.gesbas_clie_porta,
                'gesbas_aces_dia': datetime.strptime(acessos.gesbas_aces_data_hora, '%Y-%m-%d %H:%M:%S').strftime('%Y-%m-%d'), # ano-mes-dia
                'gesbas_aces_semana': datetime.strptime(acessos.gesbas_aces_data_hora, '%Y-%m-%d %H:%M:%S').strftime('%Y-%U'), # ano-semana
                'gesbas_aces_mes': datetime.strptime(acessos.gesbas_aces_data_hora, '%Y-%m-%d %H:%M:%S').strftime('%Y-%m') # ano-mes
            }
            res[acessos.id] = vals
    return res
