# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2010 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import fields, osv

class wiz_gesbas_acessos_consultas(osv.TransientModel):

    def _wizgbacco_get_bases(self, cr, uid, context=None):
        res = []
        for i in self.pool.get('gesbas.acessos').read_group(cr, uid, [],
                                                            ['gesbas_aces_base'],
                                                            'gesbas_aces_base',
                                                            context=context):
            res.append((i.get('gesbas_aces_base'), i.get('gesbas_aces_base')))
        return res

    def _wizgbacco_get_servidores(self, cr, uid, context=None):
        res = []
        for i in self.pool.get('gesbas.acessos').read_group(cr, uid, [],
                                                            ['gesbas_aces_servidor'],
                                                            'gesbas_aces_servidor',
                                                            context=context):
            res.append((i.get('gesbas_aces_servidor'), i.get('gesbas_aces_servidor')))
        return res

    def _wizgbacco_get_portas(self, cr, uid, context=None):
        res = []
        _servidor = None
        if context.get('servidor'):
            _servidor = context.get('servidor')
        if not _servidor:
            return res
        for i in self.pool.get('gesbas.acessos').read_group(cr, uid, [('gesbas_aces_servidor', '=', _servidor)],
                                                            ['gesbas_aces_porta'],
                                                            ['gesbas_aces_porta'],
                                                            context=context):
            _dado = '%s-%s' % (_servidor, i.get('gesbas_aces_porta'))
            res.append((_dado, _dado))
        return res

    _name = "wiz.gesbas.acessos.consultas"
    _columns = {
        'wizgbacco_fil_visao': fields.selection([('S', 'Servidor'), ('B', 'Base'), ('P', 'Periodo')],
                                                'Visao por',
                                                required=True,
                                                size=1),
        'state': fields.selection([('E', 'Esboco'), ('P', 'Pesquisado')], 'Estado', size=1),
        'wizgbacco_fil_base': fields.selection(_wizgbacco_get_bases, 'Base', size=30),
        'wizgbacco_fil_servidor': fields.selection(_wizgbacco_get_servidores, 'Servidor', size=20),
        'wizgbacco_fil_porta': fields.selection(_wizgbacco_get_portas,'Porta', size=25),
        'wizgbacco_fil_dia_ini': fields.char('Dia inicial', size=10),
        'wizgbacco_fil_dia_fim': fields.char('Dia final', size=10),
        'wizgbacco_fil_semana_ini': fields.char('Semana inicial', size=7),
        'wizgbacco_fil_semana_fim': fields.char('Semana final', size=7),
        'wizgbacco_fil_mes_ini': fields.char('Mes inicial', size=7),
        'wizgbacco_fil_mes_fim': fields.char('Mes final', size=7),
        'wizgbacco_linha_ids': fields.one2many('wiz.gesbas.acessos.consultas.linhas', 'wizgbaccol_capa_id', 'Linhas'),
    }
    _defaults = {
        'state': 'E',
    }


class wiz_gesbas_acessos_consultas_linhas(osv.TransientModel):

    _name = "wiz.gesbas.acessos.consultas.linhas"
    _columns = {
        'wizgbaccol_capa_id': fields.many2one('wiz.gesbas.acessos.consultas', 'Capa', required=True),
        'wizgbaccol_visao': fields.char('Visao', size=30),
        'wizgbaccol_periodo': fields.char('Periodo', size=10),
        'wizgbaccol_acessos': fields.integer('Acessos'),
    }