# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.report import report_sxw
import subprocess
import base64
import uuid
import random
import string
from ...report.rel_madeireirapedidos import rel_madeireirapedidos

def random_name():
    random.seed()
    d = [random.choice(string.ascii_letters) for x in xrange(3)]
    name = "".join(d)
    return name


class estoquepedidos_pedido_capa(osv.Model):

    _inherit = 'estoquepedidos.pedido.capa'

    def pedcap_button_print_separacao(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}

        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'madeireira_estoquepedidos_separacao',
            'datas': {'ids': ids},
        }

    def pedcap_button_imprimir(self, cr, uid, ids, context=None):
        '''
        Imprime o pedido do madeireira
        :param cr:
        :param uid:
        :param ids:
        :param context:
        :return:
        '''

        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'pedcap_ja_impresso': True}, context)

        if isinstance(ids, (list, tuple)):
            ids = ids[0]
        dados_parametro = self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', ['estpar_pedido_formato_impressao',
                                 'estpar_pedido_retrato_paisagem',
                                 'estpar_impressora_pedido',
                                 'estpar_vias_pedido',
                                 'estpar_pedido_tipo_codigo',
                                 'estpar_comando_guilhotina'])
        if isinstance(ids, (list, tuple)):
            ids = ids[0]

        context.update({'active_id': ids,
                        'active_ids': [ids],
                        'active_model': 'estoquepedidos.pedido.capa'})

        path, papel, orientacao = self.pool.get('estoque.parametro').estpar_get_path_rml_pedido(cr, uid, context=context)
        if orientacao == 'p':
            report_name = 'report pedido madeireira paisagem'
        else:
            report_name = 'report pedido madeireira retrato'
        obj_ir_act_report_xml = self.pool.get('ir.actions.report.xml')
        report_id = obj_ir_act_report_xml.search(
            cr, uid, [('report_name', '=', report_name)], context=context)
        report_xml = obj_ir_act_report_xml.browse(cr, uid, report_id[0])
        documento = 'report.%s' % self.browse(cr, uid, ids, context).numero_pedido
        documento += random_name()

        report_pdf = report_sxw.report_sxw(
            documento,
            'estoquepedidos.pedido.capa',
            path,
            parser=rel_madeireirapedidos).create_single_pdf(
                        cr, uid, [ids], {'report_type': 'pdf'}, report_xml, context
                   )

        _pdf = base64.b64encode(report_pdf[0])
        if dados_parametro.get('estpar_impressora_pedido'):
            impressora = "-d" + dados_parametro.get('estpar_impressora_pedido')
            quantidade_vias = "-n%s" % dados_parametro.get('estpar_vias_pedido')
            media = '-o media=%s' % papel
            if dados_parametro.get('estpar_pedido_formato_impressao') in ('1', '2'): # A4 e A5
                if report_pdf:
                    arq = '/tmp/%s' % uuid.uuid4()
                    p = open(arq, 'wb')
                    p.write(report_pdf[0])
                    p.close()
                    if orientacao == 'r':
                        subprocess.call(
                            ["lp", media, '-o fit-to-page', quantidade_vias, impressora, arq])
                    else:
                        subprocess.call(
                            ["lp", media, '-o landscape -o fit-to-page', quantidade_vias, impressora, arq])
                    subprocess.call(['rm', arq])
        return {'type': 'ir.actions.report.xml',
                'report_name': 'relatorios',
                'name': self.browse(cr, uid, ids, context).numero_pedido,
                'datas': {'pdf': {'estrutura': {'pdf': True},
                                  'dados': _pdf}}}
