# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2010 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################


from openerp.osv import fields, osv
from openerp import pooler
from SigUtils import mysql, datas


class marcacao_importar_osv(osv.TransientModel):
    _name = "marcacao.importar.osv"
    _description = "Wizard para importacao de marcacoes de ponto"
    _columns = {
        'data_inicial': fields.date('Data Inicial'),
        'data_final': fields.date('Data Inicial'),
    }

    def timedelta_to_float(self, cr, uid, timedelta):
        timedelta = str(timedelta)
        try:
            hora = float(timedelta[:2])
        except:
            hora = float(timedelta[0])
        try:
            minuto = float(timedelta[3:5])
        except:
            minuto = float(timedelta[2:4])
        timedelta = round((hora + (minuto / 60)), 2)
        return timedelta

    def importar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        _registros = self.browse(cr, uid, ids, context=context)
        for _registro in _registros:
            _data_inicial = _registro['data_inicial']
            _data_final = _registro['data_final']
        _data_final = datas.sigDatas(_data_final).getDataNoFormato('I', 'S', separador='-')
        _data_inicial = datas.sigDatas(_data_inicial).getDataNoFormato('I', 'S', separador='-')
        obj_parametro = pooler.get_pool(cr.dbname).get('rh.parametro')
        parametro_ids = obj_parametro.search(cr, uid, ['all'], context=context)
        parametro_dados = obj_parametro.read(cr, uid, parametro_ids,
                                             ['rh_sgp_host', 'rh_sgp_porta', 'rh_sgp_banco', 'rh_sgp_usuario',
                                              'rh_sgp_senha'], context=context)
        for parametro_linha in parametro_dados:
            _host = False
            _porta = False
            _banco = False
            _usuario = False
            _senha = False
            if parametro_linha.get('rh_sgp_host'):
                _host = parametro_linha['rh_sgp_host']
            if parametro_linha.get('rh_sgp_porta'):
                _porta = parametro_linha['rh_sgp_porta']
            if parametro_linha.get('rh_sgp_banco'):
                _banco = parametro_linha['rh_sgp_banco']
            if parametro_linha.get('rh_sgp_usuario'):
                _usuario = parametro_linha['rh_sgp_usuario']
            if parametro_linha.get('rh_sgp_senha'):
                _senha = parametro_linha['rh_sgp_senha']
            if not (_host and _porta and _banco and _usuario and _senha):
                continue
            cursor = mysql.MySQLSig(_host, _usuario, _senha, _banco, _porta, 'S')

            print 'Expediente'
            # Importar Expediente
            sql = 'select * from expediente'
            obj_expediente = pooler.get_pool(cr.dbname).get('rh.expediente')
            expediente_lista = cursor.lerQueryTudo(sql)
            for expediente_linha in expediente_lista:
                _codigo = expediente_linha['cd_expediente']
                _descricao = expediente_linha['nm_expediente']
                expediente_ids = obj_expediente.search(cr, uid, [('rh_codigo', '=', _codigo)], context=context)
                if not expediente_ids:
                    obj_expediente.create(cr, uid, {'rh_codigo': _codigo, 'name': _descricao}, context)
                else:
                    obj_expediente.write(cr, uid, expediente_ids, {'name': _descricao}, context)

            print 'Periodo'
            # Importar Periodo
            sql = 'select * from periodo'
            obj_periodo = pooler.get_pool(cr.dbname).get('rh.periodo')
            periodo_lista = cursor.lerQueryTudo(sql)
            for periodo_linha in periodo_lista:
                _codigo = periodo_linha['cd_periodo']
                _expediente = periodo_linha['EXPEDIENTE_cd_expediente']
                _expediente_ids = obj_expediente.search(cr, uid, [('rh_codigo', '=', _expediente)], context=context)
                if _expediente_ids:
                    _expediente_id = _expediente_ids[0]
                else:
                    _expediente_id = False
                _entrada = self.timedelta_to_float(cr, uid, periodo_linha['hr_entrada'])
                _saida = self.timedelta_to_float(cr, uid, periodo_linha['hr_saida'])
                periodo_ids = obj_periodo.search(cr, uid, [('rh_codigo', '=', _codigo)], context=context)
                if not periodo_ids:
                    obj_periodo.create(cr, uid, {'rh_codigo': _codigo, 'rh_expediente_id': _expediente_id,
                                                 'rh_hora_entrada': _entrada, 'rh_hora_saida': _saida}, context)
                else:
                    obj_periodo.write(cr, uid, periodo_ids,
                                      {'rh_expediente': _expediente_id, 'rh_hora_entrada': _entrada,
                                       'rh_hora_saida': _saida}, context)

            print 'justificativa'
            # Importar justificativa
            sql = 'select * from justificativa'
            obj_justificativa = pooler.get_pool(cr.dbname).get('rh.justificativa')
            justificativa_lista = cursor.lerQueryTudo(sql)
            for justificativa_linha in justificativa_lista:
                _codigo = justificativa_linha['cd_justificativa']
                _descricao = justificativa_linha['ds_justificativa']
                _tipo = justificativa_linha['tp_justificativa']
                justificativa_ids = obj_justificativa.search(cr, uid, [('rh_codigo', '=', _codigo)], context=context)
                if not justificativa_ids:
                    obj_justificativa.create(cr, uid, {'rh_codigo': _codigo, 'name': _descricao, 'rh_tipo': _tipo},
                                             context)
                else:
                    obj_justificativa.write(cr, uid, justificativa_ids, {'name': _descricao}, context)

            print 'cargo'
            # Importar Cargo
            sql = 'select * from cargo'
            obj_cargo = pooler.get_pool(cr.dbname).get('rh.cargo')
            cargo_lista = cursor.lerQueryTudo(sql)
            for cargo_linha in cargo_lista:
                _codigo = cargo_linha['cd_cargo']
                _descricao = cargo_linha['nm_cargo']
                cargo_ids = obj_cargo.search(cr, uid, [('rh_codigo', '=', _codigo)], context=context)
                if not cargo_ids:
                    obj_cargo.create(cr, uid, {'rh_codigo': _codigo, 'name': _descricao, 'cbo': _codigo}, context)
                else:
                    obj_cargo.write(cr, uid, cargo_ids, {'name': _descricao}, context)

            print 'funcionario'
            # Importar Funcionario
            sql = 'select * from funcionario'
            obj_funcionario = pooler.get_pool(cr.dbname).get('rh.funcionario')
            obj_pessoa = pooler.get_pool(cr.dbname).get('adm.pessoa')
            funcionario_lista = cursor.lerQueryTudo(sql)
            for funcionario_linha in funcionario_lista:
                _codigo = funcionario_linha['cd_funcionario']
                _cargo = funcionario_linha['CARGO_cd_cargo']
                _cargo_ids = obj_cargo.search(cr, uid, [('rh_codigo', '=', _cargo)], context=context)
                if _cargo_ids:
                    _cargo_id = _cargo_ids[0]
                else:
                    _cargo_id = False
                _funcionario_nome = funcionario_linha['nm_funcionario']
                _funcionario_pis = funcionario_linha['ds_pis']
                _funcionario_cpf = funcionario_linha['ds_cpf']
                _funcionario_nascimento = funcionario_linha['dt_nascimento']
                _funcionario_matricula = funcionario_linha['ds_matricula']
                _funcionario_admissao = funcionario_linha['dt_admissao']
                _funcionario_rua = funcionario_linha['ds_rua']
                _funcionario_numero = funcionario_linha['ds_numero']
                _funcionario_status = funcionario_linha['st_funcionario']
                _funcionario_ids = obj_funcionario.search(cr, uid, [('matricula', '=', _funcionario_matricula)],
                                                          context=context)
                if _funcionario_cpf != '00000000000':
                    _pessoa_ids = obj_pessoa.search(cr, uid, [('cpf_cnpj', '=', _funcionario_cpf)], context=context)
                    if _pessoa_ids:
                        _pessoa_id = _pessoa_ids[0]
                    else:
                        _vals_pessoa = {
                            'name': _funcionario_nome,
                            'pessoa_tipo': 'F',
                            'active': True,
                            'admpes_fis_data_nascimento': _funcionario_nascimento,
                        }
                        if _funcionario_cpf != '00000000000':
                            _vals_pessoa['cpf_cnpj'] = _funcionario_cpf
                        _pessoa_id = obj_pessoa.create(cr, uid, _vals_pessoa, context)
                    if not _funcionario_ids:
                        _vals_funcionario = {
                            'pessoa': _pessoa_id,
                            'matricula': _funcionario_matricula,
                            'cargo': _cargo_id,
                            'rh_dt_admissao': _funcionario_admissao,
                        }
                        context = {'nao_validar': True}
                        _funcionario_id = obj_funcionario.create(cr, uid, _vals_funcionario, context)
                    else:
                        if _funcionario_status == 'A':
                            _ativo = True
                        else:
                            _ativo = False
                        _vals_funcionario = {
                            'cargo': _cargo_id,
                            'active': _ativo,
                        }
                        _funcionario_id = obj_funcionario.write(cr, uid, _funcionario_ids, _vals_funcionario, context)

            print 'Jornada'
            # Importar jornada
            sql = 'select J.*, F.ds_matricula from jornada J left join funcionario F on F.cd_funcionario = J.FUNCIONARIO_cd_funcionario'
            obj_jornada = pooler.get_pool(cr.dbname).get('rh.jornada')
            jornada_lista = cursor.lerQueryTudo(sql)
            for jornada_linha in jornada_lista:
                _codigo = jornada_linha['cd_jornada']
                _data = jornada_linha['dt_jornada']
                _dom = jornada_linha['dom']
                _seg = jornada_linha['seg']
                _ter = jornada_linha['ter']
                _qua = jornada_linha['qua']
                _qui = jornada_linha['qui']
                _sex = jornada_linha['sex']
                _sab = jornada_linha['sab']
                _funcionario_matricula = jornada_linha['ds_matricula']
                jornada_ids = obj_jornada.search(cr, uid, [('rh_codigo', '=', _codigo)], context=context)
                _funcionario_ids = obj_funcionario.search(cr, uid, [('matricula', '=', _funcionario_matricula)],
                                                          context=context)
                if _funcionario_ids:
                    _funcionario_id = _funcionario_ids[0]
                    vals = {
                        'rh_codigo': _codigo,
                        'rh_funcionario_id': _funcionario_id,
                        'rh_data': _data,
                    }
                    lista = ['dom', 'seg', 'ter', 'qua', 'qui', 'sex', 'sab']
                    for dia in lista:
                        dia = '_' + dia
                        if eval(dia) > 0:
                            _expediente_ids = obj_expediente.search(cr, uid, [('rh_codigo', '=', eval(dia))],
                                                                    context=context)
                            if _expediente_ids:
                                vals['rh' + dia] = _expediente_ids[0]
                    if not jornada_ids:
                        obj_jornada.create(cr, uid, vals, context)
                    else:
                        obj_jornada.write(cr, uid, jornada_ids, vals, context)

            print 'Afastamento'
            # Importar afastamento
            sql = 'select A.*, F.ds_matricula from afastamento A left join funcionario F on F.cd_funcionario = A.FUNCIONARIO_cd_funcionario'
            obj_afastamento = pooler.get_pool(cr.dbname).get('rh.afastamento')
            afastamento_lista = cursor.lerQueryTudo(sql)
            for afastamento_linha in afastamento_lista:
                _codigo = afastamento_linha['cd_afastamento']
                _justificativa = afastamento_linha['JUSTIFICATIVA_cd_justificativa']
                _justificativa_ids = obj_justificativa.search(cr, uid, [('rh_codigo', '=', _justificativa)],
                                                              context=context)
                _funcionario_matricula = afastamento_linha['ds_matricula']
                _data_ini = afastamento_linha['dt_ini']
                _data_fim = afastamento_linha['dt_fim']
                _tipo = afastamento_linha['tp_afastamento']
                _minutos = afastamento_linha['mi_afastado']
                afastamento_ids = obj_afastamento.search(cr, uid, [('rh_codigo', '=', _codigo)], context=context)
                _funcionario_ids = obj_funcionario.search(cr, uid, [('matricula', '=', _funcionario_matricula)],
                                                          context=context)
                if _funcionario_ids:
                    _funcionario_id = _funcionario_ids[0]
                    vals = {
                        'rh_codigo': _codigo,
                        'rh_funcionario_id': _funcionario_id,
                        'rh_justificativa_id': _justificativa_ids[0],
                        'rh_data_ini': _data_ini,
                        'rh_data_fim': _data_fim,
                        'rh_tipo': _tipo,
                        'rh_minutos': _minutos,
                    }
                    if not afastamento_ids:
                        obj_afastamento.create(cr, uid, vals, context)
                    else:
                        obj_afastamento.write(cr, uid, afastamento_ids, vals, context)

            print 'marcacao'
            # Importar Marcacao
            obj_marcacao = pooler.get_pool(cr.dbname).get('rh.marcacao')
            sql = 'select M.*, F.ds_matricula from marcacao M left join funcionario F on F.cd_funcionario = M.FUNCIONARIO_cd_funcionario '
            sql += 'where dt_marcacao between "%s" and "%s"' % (_data_inicial, _data_final)
            marcacao_lista = cursor.lerQueryTudo(sql)
            for marcacao_linha in marcacao_lista:
                _funcionario_matricula = marcacao_linha['ds_matricula']
                _data = str(marcacao_linha['dt_marcacao'])
                _horario = self.timedelta_to_float(cr, uid, marcacao_linha['hr_marcacao'])
                _codigo = marcacao_linha['cd_marcacao']
                _tipo = marcacao_linha['tp_marcacao']
                _status = marcacao_linha['fl_marcacao']  # fl_marcacao = 'D' e para desconsiderar
                _funcionario_ids = obj_funcionario.search(cr, uid, [('matricula', '=', _funcionario_matricula)],
                                                          context=context)
                if _funcionario_ids:
                    args = [('rh_codigo', '=', _codigo)]
                    marcacao_ids = obj_marcacao.search(cr, uid, args, context=context)
                    if not marcacao_ids:
                        if _status != 'D':  # se for D, e para desconsiderar
                            _vals_marcacao = {
                                'rh_funcionario_id': _funcionario_ids[0],
                                'rh_codigo': _codigo,
                                'rh_data': _data,
                                'rh_horario': _horario,
                                'rh_tipo': _tipo
                            }
                            obj_marcacao.create(cr, uid, _vals_marcacao, context)
                    else:
                        if _status == 'D':  # Excluir marcacao
                            obj_marcacao.unlink(cr, uid, marcacao_ids)
        return {'type': 'ir.actions.act_window_close'}
