# -*- coding: utf-8 -*-
#
# OBS: para funcionar eh preciso que tenha a pasta 'static' dentro do modulo

import openerp.addons.web.http as http
from ..valida.controller import MySock as Ms
import json
import xmlrpclib, socket
from logging import getLogger
_logger = getLogger("Supervisor")

SEM_ERRO = '00'
ERRO_CONEXAO = '01'
ERRO_CONFIGURACAO = '02'
ERRO_INTERNO = '99'


class MySock(Ms):
    def execute(self, model, function, *args):
        return self.sock.execute(self.db, self.uid, self.pwd, 'supervisor.util',
                                 'supervisor_get_funcao', model, function, *args)



class sc_supervisor(http.Controller):
    _cp_path = '/supervisor'

    @http.httprequest
    def teste(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        ip = req.httprequest.environ.get('REMOTE_ADDR')
        print ip
        return json.dumps({'codigo': SEM_ERRO,
                           'mensagem': 'ok',
                           'retorno': [ip]})

    @http.httprequest
    def ctrl_sup_atualizar_ip_caixa(self, req, s_action=None, **kw):
        """Deve retornar uma string para nao ocorrer erro"""
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        ip = req.httprequest.environ.get('REMOTE_ADDR')
        loja = int(kw.get('loja') or 0)
        caixa = int(kw.get('caixa') or 0)
        bd_caixa = kw.get('bd_caixa') or ''
        usuario_bd_caixa = kw.get('usuario_bd_caixa') or ''
        if not loja or not caixa:
            return json.dumps({'codigo': SEM_ERRO,
                               'mensagem': 'ok',
                               'retorno': []})

        dbname = kw.get('bd')
        senha = kw.get('senha')
        usuario = kw.get('usuario')
        host, port = req.httprequest.environ.get('HTTP_HOST').split(':')

        try:
            sock_common = xmlrpclib.ServerProxy('http://%s:%s/xmlrpc/common' % (host, port))
            socket.setdefaulttimeout(3)
            uid = sock_common.login(dbname, usuario, senha)
            sock = xmlrpclib.ServerProxy('http://%s:%s/xmlrpc/object' % (host, port))
        except Exception as e:
            return json.dumps({'codigo': ERRO_CONEXAO,
                               'mensagem': 'Erro: %s' % e,
                               'retorno': [],
                               })

        args = [('suppdv_loja', '=', loja),
                ('suppdv_caixa', '=', caixa)]
        pdv_ids = sock.execute(dbname, uid, senha, 'supervisor.cad.pdvs', 'search',
                                    args, 0, False, '', {})
        if not pdv_ids:
            sock.execute(dbname, uid, senha, 'supervisor.cad.pdvs', 'create',
                         {'suppdv_loja':loja,
                          'suppdv_caixa': caixa,
                          'suppdv_ip_caixa': ip,
                          'suppdv_banco': bd_caixa,
                          'suppdv_usuario_banco': usuario_bd_caixa,})
            return json.dumps({'codigo': SEM_ERRO,
                               'mensagem': 'ok',
                               'retorno': []})

        dados_pdv = sock.execute(dbname, uid, senha, 'supervisor.cad.pdvs', 'read', pdv_ids[0],
                                 ['suppdv_ip_caixa', 'suppdv_banco', 'suppdv_usuario_banco'])
        if dados_pdv.get('suppdv_ip_caixa') == ip and dados_pdv.get('suppdv_banco') == bd_caixa and \
            dados_pdv.get('suppdv_usuario_banco') == usuario_bd_caixa:
            return json.dumps({'codigo': SEM_ERRO,
                               'mensagem': 'ok',
                               'retorno': []})

        sock.execute(dbname, uid, senha, 'supervisor.cad.pdvs', 'write', pdv_ids[0],
                     {'suppdv_ip_caixa': ip,
                      'suppdv_banco': bd_caixa,
                      'suppdv_usuario_banco': usuario_bd_caixa,})
        return json.dumps({'codigo': SEM_ERRO,
                           'mensagem': 'ok',
                           'retorno': []})

    @http.httprequest
    def ctrl_sup_get_emrpesa(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        try:
            sock = MySock(req.params)
            res = sock.execute('supervisor.cfg.configuracao',
                               'search', [])
            if not res:
                return json.dumps({'codigo': ERRO_CONFIGURACAO,
                                   'mensagem': 'Sem configuracao do SUPERVISOR',
                                   'retorno': []})
            res = sock.execute('supervisor.cfg.configuracao', 'read', res[0], ['supcfc_nro_empresa'])
            if not res.get('supcfc_nro_empresa'):
                return json.dumps({'codigo': ERRO_CONFIGURACAO,
                                   'mensagem': 'Sem empresa cadastrada na configuracao do SUPERVISOR',
                                   'retorno': []})

            return json.dumps({'codigo': SEM_ERRO,
                               'mensagem': '',
                               'retorno': [res.get('supcfc_nro_empresa')]})

        except Exception as e:
            return json.dumps({'codigo': ERRO_CONEXAO,
                               'mensagem': 'Erro: %s' % e,
                               'retorno': [],
                               })

    @http.httprequest
    def ctrl_sup_get_davs(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        try:
            sock = MySock(req.params)
            args = eval(req.params.get('args'))
            campos = eval(req.params.get('campos'))
            res = sock.execute('supervisor.dav.capa', 'search', args)
            if not res:
                return json.dumps({'codigo': SEM_ERRO,
                                   'mensagem': '',
                                   'retorno': []})

            res = sock.execute('supervisor.dav.capa', 'read', res, campos)
            return json.dumps({'codigo': SEM_ERRO,
                               'mensagem': '',
                               'retorno': res})

        except Exception as e:
            return json.dumps({'codigo': ERRO_CONEXAO,
                               'mensagem': 'Erro: %s' % e,
                               'retorno': [],
                               })

    @http.httprequest
    def ctrl_sup_write_dav(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        try:
            sock = MySock(req.params)
            vals = eval(req.params.get('vals'))
            dav_id = vals.pop('id')
            sock.execute('supervisor.dav.capa', 'write', dav_id, vals)
            return json.dumps({'codigo': SEM_ERRO,
                               'mensagem': '',
                               'retorno': []})

        except Exception as e:
            return json.dumps({'codigo': ERRO_CONEXAO,
                               'mensagem': 'Erro: %s' % e,
                               'retorno': [],
                               })

    @http.httprequest
    def ctrl_sup_deletar_dav(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        try:
            sock = MySock(req.params)
            sock.execute('supervisor.dav.capa', 'unlink', int(req.params.get('id')))
            return json.dumps({'codigo': SEM_ERRO,
                               'mensagem': '',
                               'retorno': []})

        except Exception as e:
            return json.dumps({'codigo': ERRO_CONEXAO,
                               'mensagem': 'Erro: %s' % e,
                               'retorno': [],
                               })

    @http.httprequest
    def ctrl_sup_get_vendedor(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        try:
            sock = MySock(req.params)
            args = eval(req.params.get('args'))
            campos = eval(req.params.get('campos'))
            vendedor_ids = sock.execute('supervisor.cad.vendedor', 'search', args)
            if not vendedor_ids:
                return json.dumps({'codigo': SEM_ERRO,
                                   'mensagem': '',
                                   'retorno': []})
            res = {}
            for i in sock.execute('supervisor.cad.vendedor', 'read', vendedor_ids, campos):
                res[i.get('supven_codigo')] = i

            return json.dumps({'codigo': SEM_ERRO,
                               'mensagem': '',
                               'retorno': [res]})

        except Exception as e:
            return json.dumps({'codigo': ERRO_CONEXAO,
                               'mensagem': 'Erro: %s' % e,
                               'retorno': [],
                               })

    @http.httprequest
    def ctrl_sup_criar_dav(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        try:
            sock = MySock(req.params)
            vals_capa = eval(req.params.get('vals_capa'))
            vals_capa.pop('id')
            capa_id = sock.execute('supervisor.dav.capa', 'create', vals_capa)
            itens = eval(req.params.get('itens'))
            for i in itens:
                i['supdvo_capa_id'] = capa_id
                sock.execute('supervisor.dav.corpo', 'create', i)

            fechamentos = eval(req.params.get('fechamentos'))
            for i in fechamentos:
                i['supdvf_capa_id'] = capa_id
                vencimentos = i.pop('vencimentos')
                fec_id = sock.execute('supervisor.dav.fechamento', 'create', i)
                for v in vencimentos:
                    v['supdvv_fechamento_id'] = fec_id
                    sock.execute('supervisor.dav.vencimentos', 'create', v)

            return json.dumps({'codigo': SEM_ERRO,
                               'mensagem': '',
                               'retorno': []})

        except Exception as e:
            return json.dumps({'codigo': ERRO_CONEXAO,
                               'mensagem': 'Erro: %s' % e,
                               'retorno': [],
                               })

    @http.httprequest
    def ctrl_sup_atualiza_dav(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        try:
            sock = MySock(req.params)
            numeros_dav = eval(req.params.get('numero_davs'))
            vals = eval(req.params.get('vals') or '{}')
            dav_ids = sock.execute('supervisor.dav.capa', 'search',
                                   [('supdva_nro_pedido', 'in', numeros_dav)])
            sock.execute('supervisor.dav.capa', 'write', dav_ids, vals)
            return json.dumps({'codigo': SEM_ERRO,
                               'mensagem': '',
                               'retorno': []})

        except Exception as e:
            return json.dumps({'codigo': ERRO_CONEXAO,
                               'mensagem': 'Erro: %s' % e,
                               'retorno': [],
                               })