#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _


class supervisor_cad_promo8(osv.Model):

    _name = 'supervisor.cad.promo8'
    _inherit = 'supervisor.cad.promo8'

    def onchange_suppro8_barras(self, cr, uid, ids, codigo_barras, context=None):
        context = context and context.copy() or {}
        if not codigo_barras:
            return {'value':{'suppro8_descricao': '', 'suppro8_controle':''}}

        args = [('supite_codigo_item','=',str(codigo_barras).zfill(14))]
        itens_ids = self.pool.get('supervisor.cad.itens').search(cr, uid, args, context=context)

        if not itens_ids:
            warning = {'title': _('Atencao!')}
            warning['message'] = _('Nao ha item para este codigo de barras!')
            return {'value': {'suppro8_barras': '', 'suppro8_descricao': '', 'suppro8_controle':''},
                    'warning': warning}

        dados_item = self.pool.get('supervisor.cad.itens').read(cr, uid, itens_ids[0],
                                                                ['name'], context=context)
        descricao = dados_item.get('name') or ''
        return {'value':{'suppro8_descricao': str(descricao), 'suppro8_controle':''}}

    def onchange_suppro8_descricao(self, cr, uid, ids, descricao, controle, context=None):
        context = context and context.copy() or {}
        if controle:
            warning = {'title': _('Atencao!')}
            warning['message'] = _('A descricao nao pode ser alterada!')
            return {'warning': warning, 'value': {'suppro8_descricao': controle}}

        return {'value':{'suppro8_controle': descricao}}

    def create(self, cr, user, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('suppro8_barras'):
            vals['suppro8_barras'] = '%s' % vals.get('suppro8_barras').zfill(14)

        return super(supervisor_cad_promo8, self).create(cr, user, vals, context=context)

    def write(self, cr, user, ids, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('suppro8_barras'):
            vals['suppro8_barras'] = '%s' % vals.get('suppro8_barras').zfill(14)

        return super(supervisor_cad_promo8, self).write(cr, user, ids, vals, context=context)

