#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class supervisor_cad_promo8(osv.Model):
    """
    PACOTE COM DESCONTO PERCENTUAL, CRIADO PARA DESCONTO DE UMA EMPRESA ESPECIFICA
    PARA SEUS FUNCIONARIOS
    Três unidades de qualquer um dos seguintes itens:
    7891050000101 - WHISKY PASSPORT 1000ML
    e levando uma unidade de qualquer um dos seguintes ítens:
    7622300807283 - CHOCOLATE LACTA BIS LAKA SNACKS BRANCO 126G
    Desconto total de 5%
    Prefixo: suppro8
    """
    from funcoes import get_default_suppro_quantidade, get_default_suppro_desconto

    _name = 'supervisor.cad.promo8'
    _rec_name = 'suppro8_barras'
    _gerar_logs_logs = 'N'
    _columns = {
        'suppro8_capa_id': fields.many2one('supervisor.cad.promo_capa','Capa',ondelete="cascade",
                                           required=True, select=True),
        'suppro8_barras': fields.char('Codigo de barras', size=14, required=True, select=True),
        'suppro8_quantidade': fields.float('Quantidade', digits=(10, 3), required=True),
        'suppro8_desconto': fields.float('Desconto', digits=(10, 2), required=True,),
        'suppro8_tipo_desconto': fields.selection([('$', 'Valor'),
                                                   ('%', 'Percentual')],  'Tipo de desconto', required=True,),
        'suppro8_sequencial': fields.integer('Sequencial', required=True),
        'suppro8_controle': fields.char('Controle', size=30), # controla de onde vem a alteracao do campo de descricao
        'suppro8_descricao': fields.char('Descricao', size=30),
    }
    _defaults = {
        'suppro8_quantidade': get_default_suppro_quantidade,
        'suppro8_desconto': get_default_suppro_desconto,
        'suppro8_sequencial': 1,
        'suppro8_tipo_desconto':'%',
    }
