#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _


class supervisor_cad_sorteio_itens(osv.Model):


    _inherit = 'supervisor.cad.sorteio.itens'
    
    def create(self, cr, user, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('supsit_barras'):
            vals['supsit_barras'] = '%s' % vals.get('supsit_barras').zfill(14)

        return super(supervisor_cad_sorteio_itens, self).create(cr, user, vals, context=context)

    def write(self, cr, user, ids, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('supsit_barras'):
            vals['supsit_barras'] = '%s' % vals.get('supsit_barras').zfill(14)

        return super(supervisor_cad_sorteio_itens, self).write(cr, user, ids, vals, context=context)
    
    def onchange_supsit_barras(self, cr, uid, ids, codigo_barras, context=None):
        context = context and context.copy() or {}
        if not codigo_barras:
            return {'value':{'supsit_descricao': ''}}

        args = [('supite_codigo_item','=',str(codigo_barras).zfill(14))]
        itens_ids = self.pool.get('supervisor.cad.itens').search(cr, uid, args, context=context)

        if not itens_ids:
            warning = {'title': _('Atencao!')}
            warning['message'] = _('Nao ha item para este codigo de barras!')
            return {'value': {'supsit_barras': '', 'supsit_descricao': ''},
                    'warning': warning}

        dados_item = self.pool.get('supervisor.cad.itens').read(cr, uid, itens_ids[0],
                                                                ['name'], context=context)
        descricao = dados_item.get('name') or ''
        return {'value':{'supsit_descricao': str(descricao)}}
