#!/usr/bin/python
# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class supervisor_cad_sorteio(osv.Model):
    """
    Tabela de sorteios
    Prefixo: supsor

    """

    _name = 'supervisor.cad.sorteio'
    _gerar_logs_logs = 'N'
    _columns = {
        'name': fields.char('Nome', size=60, help='Nome para identificar o sorteio.'),
        'supsor_data_inicio': fields.date('Data inicial', required=True, select=True),
        'supsor_data_fim': fields.date('Data Final', required=True, select=True),
        'supsor_valor': fields.float('Valor', required=True,  digits=(10, 2),
                                     help=_('Valor minimo de compra necessario para ganhar um '
                                            'cupom')),
        'supsor_descricao': fields.text('Descricao', required=True),
        'state': fields.selection([('1', 'Esboco'),
                                   ('2', 'Ativo')], 'Estado', select=True, size=1),
        'supsor_item_ids': fields.one2many('supervisor.cad.sorteio.itens',
                                              'supsit_capa_id', 'Itens'),
        'supsor_limitador': fields.selection([('1', 'Limitar por Valor'),
                                              ('2', 'Limitar por Itens'),],
                                             'Limitador de vias impressas',
                                             help="Usado apenas quando tiver itens no sorteio!"
                                                  "\n\nQuando marcado por valor, o numero de impressoes sera o valor da venda dividido pelo valor do sorteio, contendo pelo menos o minimo de itens informado."
                                                  "\n\nQuando marcado por itens, o numero de impressoes sera a quantidade de itens vendidos divido pela quantidade de itens no sorteio, com pelo menos o valor do sorteio informado."
                                                  "\n\nSem marca nenhum limitador, o numero de impressoes sera quantas vez o valor da compra mais a quantidade de itens que satisfazem o sorteio.")
    }

    _defaults = {
        'state': '1',
    }