# -*- coding: utf-8 -*-
# #############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
# www.siginformatica.com.br luiz@siginformatica.com.br
#
# #############################################################################

from openerp.osv import osv
import json


class valida_utils(osv.Model):
    _name = 'valida.utils'

    @staticmethod
    def valuti_remover_acentuacao(text, cod='utf-8'):
        """
        Funcao Wrapper para remover acentuacao
        :param text:texto onde sera feita a remocao da acentuacao
        :param cod:Tipo de codificacao
        return:string
        """
        from unicodedata import normalize, category

        try:
            unicode_string = str(text)
        except UnicodeEncodeError:
            return normalize('NFKD', text).encode('ASCII', 'ignore')

        return unicode(filter(lambda c: category(c) != 'Mn',
                              normalize('NFKD', unicode_string.decode(cod))))

    def valuti_get_funcao(self, cr, uid, model, function, *args):
        try:
            retornar_json = False
            if 'retornar_json' in args:
                args = list(args)
                args.remove('retornar_json')
                args = tuple(args)
                retornar_json = True

            _args = ','.join(map(lambda x: '%r' % x, args))
            res = eval("self.pool.get('{model}').{function}(cr, uid, {args})".format(
                model=model,
                function=function,
                args=_args))
            if retornar_json:
                return json.dumps(str(res))

            return res
        except Exception as e:
            if e.__class__ in (osv.orm.except_orm, osv.except_osv) and len(e.args) > 1:
                txt = e.args[0].encode('utf-8') + '\n' + e.args[1].encode('utf-8')
            else:
                try:
                    txt = e.message or e.value
                except:
                    txt = str(e)

            txt = self.valuti_remover_acentuacao(txt)
            raise Exception('9999', txt)
