# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2016 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2016, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import fields, osv


# noinspection PyAbstractClass,PyPep8Naming

class relatorio_pedido_venda_state_osv(osv.TransientModel):
    _name = 'relatorio.pedido.venda.state.osv'
    _columns = {
        'codigo': fields.char('Codigo', size=1),
        'name': fields.char('Estado', size=30),
    }

class relatorio_pedido_venda_osv(osv.TransientModel):
    """
    Formulario de dados de pedido de venda para elaboracao de relatorio.
    """

    _name = 'relatorio.pedido.venda.osv'

    # noinspection PyMethodMayBeStatic

    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa ', required=True),
        'vendedor_id': fields.many2one('vendas.vendedor', 'Vendedor', domain="[('tipo','=','I')]"),
        'vendedor_externo_id': fields.many2one('vendas.vendedor', 'Vendedor externo',
                                               domain="[('tipo','=','E')]"),
        'pessoa_id': fields.many2one('adm.pessoa', 'Cliente'),
        'states': fields.many2many('relatorio.pedido.venda.state.osv',
                                      'relatorio_m2m_pedido_venda_state_osv',
                                      'rel_id', 'venda_state_id', 'Estado do pedido'),

        # 'state': fields.selection(get_pedido_status, 'Estado do pedido', size=1),
        'data_ini': fields.date('Data inicial'),
        'data_fim': fields.date('Data final')
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, s._name, context=c),
        'states': lambda s, cr, uid, c: s.pool.get('relatorio.pedido.venda.state.osv').setStates(
            cr, uid, context=c),
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
