# -*- encoding: utf-8 -*-
import openerp
import openerp.addons.web.http as http
from lxml import etree
import json
from logging import getLogger
_logger = getLogger("WebSig")


class Controller(openerp.addons.web.http.Controller):
    _cp_path = "/web_sig"


    def _parse_node(self, root_node):
        result = []
        for node in root_node:
            field_name = node.get('name')
            if not eval(str(node.attrib.get('invisible', False)), {'context': {}}):
                if node.tag == 'field':
                    result.append(field_name)
                else:
                    result.extend(self._parse_node(node))
        return result

    def _parse_string(self, view):
        try:
            dom = etree.XML(view.encode('utf-8'))
        except:
            dom = etree.XML(view)
        return self._parse_node(dom)

    @http.httprequest
    def perguntas(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        import werkzeug
        print('perguntas')
        res = json.dumps({'qtd': 1})
        headers = {}
        headers['Access-Control-Allow-Origin'] = 'http://localhost'  # ou especifique o domínio, e.g., 'https://seu-dominio.com'
        headers['Access-Control-Allow-Methods'] = 'GET, POST, OPTIONS'

        return werkzeug.wrappers.Response(res, headers=[('Access-Control-Allow-Origin', '*'),
                                                        ('Content-Type', 'text/css'),
                                                              ('Content-Length', len(res))])

    @http.httprequest
    def vendas(self, req, s_action=None, **kw):
        _logger.info('==++> SigController.%s Params: %s. Data:%s' % (req.httprequest.path, req.params, req.httprequest.data))
        print('vendas')
        res = json.dumps({'qtd': 1})
        return res

    @openerp.addons.web.http.jsonrequest
    def fields_view_get(self, req, model):
        Model = req.session.model(model)
        # fields = Model.fields_get(False, req.session.eval_context(req.context))
        result = Model.fields_view_get(False, 'tree')
        parse = self._parse_string(result['arch'])
        res = []
        for f in parse:
            res.append({'name': f,
                        'string': result['fields'][f]['string']}
            )
        return res
