# -*- coding: utf-8 -*-
import os

from openerp.osv import osv
from ...adm.control.utils import admConfiguracao
from datetime import datetime
import logging


class WebmobConfiguracoes(osv.Model):

    _inherit = 'webmob.configuracoes'
    logger = logging.getLogger(_inherit)

    def wmobconf_excluir_secoes(self, cr, uid, prazo=1):
        self.logger.info('Limpando webmob.config  -> Prazo:%s' % prazo)
        for arq in os.listdir('/tmp'):
            if not arq.startswith('wmob'):
                continue
            arq = arq.replace('.config', '')
            try:
                cfg = admConfiguracao(arq, secao=None, cripto=False, dir='/tmp')
                for secao in cfg.cfg.sections():
                    cfgEmAvaliacao = admConfiguracao(arq, secao=secao, cripto=False, dir='/tmp')
                    dataHora = datetime.strptime(cfgEmAvaliacao.datahora, '%Y-%m-%d %H:%M')
                    agora = datetime.now()
                    _diff = agora - dataHora
                    self.logger.info('data hora encontrada:%s  Diferenca:%s' % (cfgEmAvaliacao.datahora, _diff))
                    if (_diff.total_seconds() / 3600.) > prazo:
                        os.remove('/tmp/%s.config' % arq)
                        break
            except:
                os.remove('/tmp/%s.config' % arq)
        return True
